Package: Compind
Type: Package
Title: Composite Indicators Functions
Version: 3.1
Date: 2024-03-25
Author: Francesco Vidoli, Elisa Fusco
Maintainer: Francesco Vidoli <fvidoli@gmail.com>
Description: A collection of functions to calculate Composite Indicators methods, focusing, in particular, on the normalisation and weighting-aggregation steps, as described in OECD Handbook on constructing composite indicators: methodology and user guide <https://www.oecd-ilibrary.org/economics/handbook-on-constructing-composite-indicators-methodology-and-user-guide_9789264043466-en>, 'Vidoli' and 'Fusco' and 'Mazziotta' <doi:10.1007/s11205-014-0710-y>, 'Mazziotta' and 'Pareto' (2016) <doi:10.1007/s11205-015-0998-2>, 'Van Puyenbroeck and 'Rogge' <doi:10.1016/j.ejor.2016.07.038> and other authors.
Depends: R (>= 3.5.0), Benchmarking, psych, boot, lpSolve, spdep
Imports: Hmisc, MASS, GPArotation, nonparaeff, smaa, np, FactoMineR,
        GWmodel, sp, Rcompadre
License: GPL-3
Suggests: R.rsp
VignetteBuilder: R.rsp
NeedsCompilation: no
Packaged: 2024-03-25 12:20:40 UTC; Fra
Repository: CRAN
Date/Publication: 2024-03-25 12:42:47 UTC
Built: R 4.2.3; ; 2024-03-25 16:16:08 UTC; unix

Package: Compind
Type: Package
Title: Composite Indicators Functions
Version: 3.6
Date: 2026-7-10
Authors@R: c(person(given = "Francesco",
                        family = "Vidoli",
                        role = c("aut", "cre"),
                        email = "fvidoli@gmail.com"),
                 person(given = "Elisa",
                        family = "Fusco",
                        role = "aut"))
Maintainer: Francesco Vidoli <fvidoli@gmail.com>
Description: A collection of functions to calculate Composite Indicators methods, focusing, in particular, on the normalisation and weighting-aggregation steps, as described in OECD Handbook on constructing composite indicators: methodology and user guide, 2008, 'Vidoli' and 'Fusco' and 'Mazziotta' <doi:10.1007/s11205-014-0710-y>, 'Mazziotta' and 'Pareto' (2016) <doi:10.1007/s11205-015-0998-2>, 'Van Puyenbroeck and 'Rogge' <doi:10.1016/j.ejor.2016.07.038> and other authors.
Depends: R (>= 3.5.0), Benchmarking, psych, boot, lpSolve, spdep
Imports: Hmisc, MASS, GPArotation, nonparaeff, smaa, np, FactoMineR,
        GWmodel, sp, Rcompadre
License: GPL-3
Suggests: R.rsp
VignetteBuilder: R.rsp
NeedsCompilation: no
Packaged: 2026-07-10 08:28:20 UTC; Fra
Repository: CRAN
Date/Publication: 2026-07-10 08:50:26 UTC
Author: Francesco Vidoli [aut, cre],
  Elisa Fusco [aut]

exportPattern("^[[:alpha:]]+")

#import(Benchmarking)
importFrom(Benchmarking, dea)
importFrom(Benchmarking, mea)
#import(psych)
importFrom(psych, principal)
#importFrom(psych, geometric.mean)
#import(boot)
importFrom(boot, boot)
importFrom(boot, boot.ci)

importFrom(nonparaeff, orderm)
importFrom(nonparaeff, ar.dual.dea)
importFrom(Rcompadre,mat_mean)

import(Hmisc)
import(MASS)
import(GPArotation)
import(lpSolve)

import(spdep)

importFrom("stats", "var")
importFrom("stats", "qt")
importFrom("stats", "sd")
importFrom("stats", "median")
importFrom("stats", "runif")
importFrom("stats", "biplot")

importFrom("FactoMineR", "FAMD")

importFrom("utils", "read.table")
importFrom("np", "npcdensbw")
importFrom("np", "npksum")

importFrom("smaa", "smaa.values")
importFrom("smaa", "smaa.ranks")

importFrom("GWmodel", "gw.dist")
importFrom("GWmodel", "gw.weight")
importFrom("GWmodel", "bw.gwss.average")

importFrom("sp", "SpatialPointsDataFrame")
importFrom("stats", "quantile")

ci_rbod <- function(x,indic_col,M,B)
{
 # library(nonparaeff)
  x_num   = x[,indic_col]
  n_indic = dim(x_num)[2]
  n_unit  = dim(x_num)[1]
  uni <- as.matrix(seq(1, 1, len = n_unit))
  data_per_Rbod = cbind(x_num,uni)
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }    

  
  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }    
  
  
  
  stima_m <- nonparaeff::orderm(data_per_Rbod, noutput = n_indic,
                                orientation = 2, M=M, B=B)
  ci_rbod_est = 1/stima_m[[1]]
  
  r<-list(ci_rbod_est=ci_rbod_est, ci_method="rbod")
  r$call<-match.call()
  class(r)<-"CI"
  return(r)
  
}

normalise_ci <- function(x, indic_col, polarity, method=1, z.mean=0, z.std=1, ties.method ="average")
  {
  
  ci_norm_finale = x
  x_num   = x[,indic_col]
  n_indic <- dim(x_num)[2]

  # Numeric check
  for (i in seq(1,n_indic)) 
    {
      if (!is.numeric(x_num[,i]))
        {
          stop(paste("Data set not numeric at column:",i))
        }
    }  
  
  
  # 1 condizione di errore: dati negativi
  for (i in seq(1,n_indic)) 
  {
    if (min(x_num[,i],na.rm = TRUE)<0) 
    {
      stop("Error: simple indicator must be positive!") 
    }
  }
                               
  #1 - Standardisation or z-scores ############################
  
  if (method==1) {
      ci_norm = x_num  
      Ma  <- colMeans(x_num, na.rm = TRUE)
      Sqm <- matrix(0, nrow=1, ncol=n_indic)
      for (i in seq(1,n_indic)) 
      {
        Sqm[i] <- sd(x_num[,i], na.rm=TRUE)
      }
        
      for (i in seq(1,n_indic)) 
      {
        if (polarity[i]=="POS") 
        {
          ci_norm[,i] = z.mean + ((x_num[,i]-Ma[i])/Sqm[i])*z.std
        }
        if (polarity[i]=="NEG") 
        {
          ci_norm[,i] = z.mean - ((x_num[,i]-Ma[i])/Sqm[i])*z.std
        }
        if (polarity[i]!="NEG" & polarity[i]!="POS")
        {
          stop("Please check polarity!") 
        }   
      }    
  }  
  
  #2 - min-max method #########################################
  
  if (method==2) {
    ci_norm = x_num
    
     min <- matrix(0, nrow=1, ncol=n_indic)    
     for (i in seq(1,n_indic)) 
     {
       min[i] <- min(x_num[,i],na.rm=TRUE)
     }
     max <- matrix(0, nrow=1, ncol=n_indic)    
     for (i in seq(1,n_indic)) 
     {
       max[i] <- max(x_num[,i],na.rm=TRUE)
     }    
  
    for (i in seq(1,n_indic)) 
      {
        if (polarity[i]=="POS") 
          {
            ci_norm[,i] = (x_num[,i]-min[i])/(max[i] - min[i])  
        }
        if (polarity[i]=="NEG") 
        {
            ci_norm[,i] = ((max[i]) - (x_num[,i])) / ((max[i]) - (min[i]))  
        }     
        if (polarity[i]!="NEG" & polarity[i]!="POS")
        {
            stop("Please check polarity!") 
        } 
      }
  }  
  
  #3 - ranking ################################################
  
  if (method==3) {
    ci_norm = x_num
    for (i in seq(1,n_indic)) 
    {
      if (polarity[i]=="POS") 
      {
        ci_norm[,i] <- rank(x_num[,i], na.last="keep")
      }
      if (polarity[i]=="NEG") 
      {
        ci_norm[,i] <- rank(-x_num[,i], na.last="keep")
      }
      if (polarity[i]!="NEG" & polarity[i]!="POS")
      {
        stop("Please check polarity!") 
      }   
    }
  }  
  
  r<-list(ci_norm=ci_norm,norm_method=method)
  #r$call<-match.call()
  #class(r)<-"norm_CI"
  return(r)
}

ci_smaa_constr <- function(x,indic_col, rep, label, low_w=NULL)
{
  x_num   = x[,indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  } 
  
  # Constraint check
  if (!is.null(low_w)) {
  n_low_w <- dim(as.matrix(low_w))[1]
      if (n_indic != n_low_w)
    {
      stop("Lower bound vector must be set as a vector of the same size as the number of simple indicators")
      }
  }


    ############# Creazione dati                ################
  ############# meas	= Criteria measurements ################
  
  N <- rep        # numero di ripetizioni 
  m <- n_unit     # alternatives = numero soggetti da valutare
  n <- n_indic    # criteria     = numero di indicatori semplici
  
  arr = array(0, dim=c(N,m,n))
  
  for(k in 1:N){
    for(j in 1:n){
      arr[k,,j] = x_num[,j]
    }
  }
  

  ######## Creazione pesi [che sommano a 1] ###################
  ######## pref	= Weights                   ###################
  
  pesi = array(0, dim=c(N,n))
  
  if (is.null(low_w)) {
    for(j in 1:n){
      pesi[,j] = runif(N, min = 0, max=1)
    }
  }

  if (!is.null(low_w)) {
    for(j in 1:n){
      pesi[,j] = runif(N, min = low_w[j], max=1)
    }
  }

  if (!is.null(low_w)) {
    somma_low = sum(low_w)
    # Numeric check
    if (somma_low>1)
    {
      stop(paste("Lower constraint too high. Lower constraint * Number of indicators=",somma_low))
    }  
  }
    
  # Normalizzo la somma dei w a 1 
  for(j in 1:n){
    pesi[,j] =pesi[,j]/sum(pesi[,j])
  }
  


  
  ############################################################
  ########### SMAA ###########################################
  
  # Costruzione della rank frequency table
  values <- smaa.values(meas=arr, pref=pesi)
  ranks  <- smaa.ranks(values)
  
  ranks_freq= array(0, dim=c(m,m))
  for(i in 1:N){
    for(j in 1:m){
      ranks_freq[ranks[i,j],j]  = ranks_freq[ranks[i,j],j] + 1
    }
  }
  
  colnames(ranks_freq) = label
  ranks_freq_t = t(ranks_freq)

  ################# rango medio ###########################
  
  somma <- matrix(0, nrow = m, ncol = 1)
  for(i in 1:m){
    for(j in 1:m){
      somma[i] = somma[i] + (j * ranks_freq_t[i,j]/rep)
    }             
  }
  rownames(somma) = label
  colnames(somma) = "Average_rank"
  


r<-list(ci_smaa_constr_rank_freq=ranks_freq_t,
        ci_smaa_constr_values = values,
        ci_smaa_constr_average_rank = somma,
        ci_method="ci_smaa_constr")
r$call<-match.call()
class(r)<-"CI"
r

}

ci_ogwa <- function(x, id, indic_col, atleastjp, coords,
                    kernel = "bisquare", adaptive = F, bw, 
                    p = 2, theta = 0, longlat = F, dMat)
{
  x_num = x[, indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  for (i in seq(1, n_indic)) {
    if (!is.numeric(x_num[, i])) {
      stop(paste("Data set not numeric at column:", i))
    }
  }
  for (i in seq(1, n_unit)) {
    for (j in seq(1, n_indic)) {
      if (is.na(x_num[i, j])) {
        message(paste("Pay attention: NA values at column:", 
                      i, ", row", j, ". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
      }
    }
  }
  ci_data = as.matrix(cbind(x_num))
  
  
  #######################################################
  #########                 OGWA                 ########
  #######################################################
  
  n=n_indic
  alfap=atleastjp/n
  wp <- c(rep(0,n-atleastjp),rep(1/atleastjp,atleastjp))
  wn <- c(rep(1/atleastjp,atleastjp),rep(0,n-atleastjp))
  
  ### matrix of all the distances between all the GW model calibration points and data points
  dist<- matrix(NA,nrow=n_unit,ncol=n_unit)
  
  for(i in 1:n_unit)
  {
    dist[,i]<-gw.dist(dp.locat=coords, focus=i, longlat=longlat) 
  }
  
  #dist<-gw.dist(dp.locat=coords,longlat=TRUE) 
  
  data_sp <- SpatialPointsDataFrame(coords, data.frame(ci_data))
  
  bw <- bw.gwss.average(data_sp,
                        vars=colnames(data_sp@data), 
                        kernel=kernel,
                        adaptive=adaptive, 
                        longlat=longlat,
                        dMat=dist)
  
  CI_OGWA_n <- matrix(NA,nrow=n_unit, ncol=n_unit)
  CI_OGWA_p <- matrix(NA,nrow=n_unit, ncol=n_unit)
  ci_data_gw.vi <- matrix(NA,nrow=n_unit, ncol=n_indic)
  
  for (i in 1:n_unit) {
    dist.vi <- gw.dist(dp.locat=coords, focus=i, longlat=longlat)
    wt.vi <- gw.weight(dist.vi, bw=mean(bw[1,]), kernel=kernel,
                       adaptive=adaptive)
    #use<- wt.vi>0.5
    for(c in 1:n_indic)
    {
      ci_data_gw.vi[,c] <- ci_data[,c]*wt.vi
    }
    
    indic_t_gw.vi <- as.data.frame(t(ci_data_gw.vi))
    
    rows<-n_indic
    cols<-dim(ci_data_gw.vi)[1]
    
    ### order each column separately without consider the indicator 
    data_ord_gw.vi <- data.frame(1:n_indic,
                                 matrix(NA,ncol=dim(ci_data_gw.vi)[1], nrow=n_indic))
    for(j in 1:dim(ci_data_gw.vi)[1])
    {
      data_ord_gw.vi[,j+1]<- sort(indic_t_gw.vi[,j], decreasing = TRUE)
    }
    colnames(data_ord_gw.vi)<- c(id,colnames(indic_t_gw.vi))
    
    data_ord_gw2.vi<- data_ord_gw.vi[,-1]
    
    #######################################################
    
    CI_OGWA_p.vi<- matrix(NA, ncol=1, nrow=cols)
    CI_OGWA_n.vi<- matrix(NA, ncol=1, nrow=cols)
    
    for(c in 1:cols)
    {
      CI_OGWA_n.vi[c,] <- sum(data_ord_gw2.vi[,c]*wp) #more than j
      CI_OGWA_p.vi[c,] <- sum(data_ord_gw2.vi[,c]*wn) #at least j
    }
    
    CI_OGWA_n[,i] <- CI_OGWA_n.vi
    CI_OGWA_p[,i] <- CI_OGWA_p.vi
    
  }
  
  CI_OGWA_n_mean=rowMeans(CI_OGWA_n)
  CI_OGWA_p_mean=rowMeans(CI_OGWA_p)
  
  r<- list(CI_OGWA_n=CI_OGWA_n_mean, CI_OGWA_p=CI_OGWA_p_mean, wp=wp, wn=wn,
           bw=bw,
           ci_method = "ogwa")
  r$call <- match.call()
  class(r) <- "CI"
  r
}  

ci_geom_bod_intertemp <- function(x0,x1,indic_col,up_w,low_w,bench)
{

  Indic_t0   = x0[,indic_col]
  Indic_t1   = x1[,indic_col]
  n_indic <- dim(as.matrix(Indic_t0))[2]
  n_unit <- dim(as.matrix(Indic_t0))[1]
  lower_w = low_w
  upper_w = up_w  
  
  ################################################################################
  #                                                                              #
  #  Intertemporal setting: period t0-t1                                         #
  #                                                                              #
  ################################################################################
  

  rowProds <- function(X){ apply(X,1,FUN="prod") }
  
  # Normalising by benchmark unit vector
  Indic_norm_t0 = sweep(Indic_t0, 2, t(Indic_t0[bench,]), "/")
  Indic_norm_t1 = sweep(Indic_t1, 2, t(Indic_t1[bench,]), "/")
  
  # Constrained BoD weights
  CI_t0 = ci_bod_constr(Indic_t0, indic_col,upper_w,lower_w)
  w_t0  = CI_t0$ci_bod_constr_weights
  CI_t1 = ci_bod_constr(Indic_t1, indic_col,upper_w,lower_w)
  w_t1  = CI_t1$ci_bod_constr_weights
  
  
  # Index calculation ########################################################################
  
  # Computations of the Indicator Change Effect (Norm) A
  ChangeEffect_Norm_t1_vs_t0 <- rowProds((Indic_norm_t1/Indic_norm_t0)^((w_t1+w_t0)/2))
  
  # Computations of the Indicator Change Effect (NO Norm) B
  ChangeEffect_t1_vs_t0      <- rowProds((Indic_t1/Indic_t0)^((w_t1+w_t0)/2))
  
  # Computations of the Benchmark Change Effect C
  benc_m = matrix(0, nrow=n_unit, ncol=n_indic)
  for (j in 1:n_unit){
    benc_m[j,] <- as.matrix((Indic_t1[bench,]/Indic_t0[bench,])^(-(w_t1[j,]+w_t0[j,])/2))
    
  }
  BenchmarkEffect_t1_vs_t0   <- rowProds(benc_m)
  
  # Computations of the Weight Change Effect D
  WeightEffect_t1_vs_t0    <- rowProds((Indic_norm_t1*Indic_norm_t0)^((w_t1-w_t0)/2))
  
  # Computation of the Overall Change
  OverallChange_t1_vs_t0     <- #ChangeEffect_Norm_t1_vs_t0 * BenchmarkEffect_t1_vs_t0 
                                ChangeEffect_t1_vs_t0 * BenchmarkEffect_t1_vs_t0 # WeightEffect_t1_vs_t0
  
  #############################################################################################  
  
  # cbind
  Intertemp_t1_vs_t0 <- cbind(OverallChange_t1_vs_t0, ChangeEffect_t1_vs_t0,
                              BenchmarkEffect_t1_vs_t0, WeightEffect_t1_vs_t0) 
  Intertemp_t1_vs_t0  
  

  r<-list(ci_geom_bod_intertemp_est=Intertemp_t1_vs_t0,
          ci_method="Intertemporal_effects_Geometric_BoD")
  r$call<-match.call()
  class(r)<-"CI"
  r


}

ci_bod_constr_bad <- function(x, indic_col, ngood=1, nbad=1, low_w=0, pref=NULL) 
{
  x_num = x[, indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  for (i in seq(1, n_indic)) {
    if (!is.numeric(x_num[, i])) {
      stop(paste("Data set not numeric at column:", i))
    }
  }
  for (i in seq(1, n_unit)) {
    for (j in seq(1, n_indic)) {
      if (is.na(x_num[i, j])) {
        message(paste("Pay attention: NA values at column:", 
                      i, ", row", j, ". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
      }
    }
  }
  if(!is.null(pref)){
      if (!is.character(pref)) {
       stop(paste("The preference vector (pref) is not of character type"))
      }
  }
  if(n_indic!=(ngood+nbad)){
    stop(paste("The number of simple indicators is not equal to the sum of the
               number of good and bad outputs, please insert the right number
               of simple indicators in x or choose the right number of columns
               in indic_col or indicate the right number of good and bad outputs
               in ngood and nbad."))
    }
  if(ngood==0){
    stop(paste("The number of good outputs (ngood) has to be greater than 0."))
  }
  if(nbad==0){
    stop(paste("The number of bad outputs (nbad) has to be greater than 0."))
  }
  
  
  x_num = as.matrix(x_num)
  
  g <- ngood
  b <- nbad
  p <- length(pref)

  Avg <- apply(x_num, 2, mean)
  
  score <- rep(0, times = n_unit)
  eff <- rep(0, times = n_unit)
  w <- cbind(matrix(0, nrow = n_unit, ncol = (n_indic)))
  final <- cbind(matrix(0, nrow = n_unit, ncol = (1+n_indic)))
  
  f.sign <- c(rep(-1, g), rep(1, b))

  for (i in 1:n_unit) {
    
    if(!is.null(pref))
    {
      
  # Different cases of ordVWR
    # Case 1: the preference vector has only 2 elements => only ordVWR_type1  
      if(length(pref)==2)
      {
             f.obj <- c(f.sign * x_num[i, ])
             
             f.dir <- c("==",rep(">=", times = n_unit), rep(">=", times = g+b), 
                        rep(">=",times=(n_indic-1)),
                        rep(">=", times = g+b))
             
             f.rhs <- c(1, rep(0, times = n_unit), rep(0, times = g+b), 
                        rep(0,times=(n_indic-1)),
                        rep(0, times = g+b))  
             
             Constr1 <- c(x_num[i,])
             Constr2 <- cbind(t(f.sign * t(x_num)))
             
             I = diag(x = 1, n_indic)
             VWRg = t((I - low_w)*as.vector(Avg)) 
             
             ### OrdVWR_type1
             I = diag(x = 1, n_indic)
             colnames(I) <- colnames(x_num)
             I[,pref[1]] <- 0
             
             M_imp =  matrix(0,nrow=(n_indic), ncol=n_indic)
             colnames(M_imp) <- colnames(x_num)
             M_imp[,pref[1]] <- 1
             
             ordVWR_type1 <- (-I*Avg) + (M_imp*Avg[pref[1]])
             ordVWR_type1 <- ordVWR_type1[-which(colnames(M_imp)==pref[1]),]
             
             Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
             Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
             
             f.con <- rbind(Constr1, Constr2, Pweight_g, Pweight_b, VWRg, ordVWR_type1)
             jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
             score[i] <- jj$objval
             w[i, ] <- rbind(jj$solution)
             final[i, ] <- c(score[i], w[i, ])
             
     # Case 2: the preference vector has all indicators         
      }
      
      if(length(pref)==n_indic){    
       
            f.obj <- c(f.sign * x_num[i, ])
            
            f.dir <- c("==",rep(">=", times = n_unit), rep(">=", times = g+b), 
                       rep(">=",times=(n_indic-1)), rep(">=",times=(p-2)), 
                       rep(">=", times = g+b))
            
            f.rhs <- c(1, rep(0, times = n_unit), rep(0, times = g+b), 
                       rep(0,times=(n_indic-1)), rep(0, times = (p-2)),
                       rep(0, times = g+b))  
            
            Constr1 <- c(x_num[i,])
            Constr2 <- cbind(t(f.sign * t(x_num))) 
            
            I = diag(x = 1, n_indic)
            VWRg = t((I - low_w)*as.vector(Avg)) 
            
            ### OrdVWR_type1
            I = diag(x = 1, n_indic)
            colnames(I) <- colnames(x_num)
            I[,pref[1]] <- 0
            
            M_imp =  matrix(0,nrow=(n_indic), ncol=n_indic)
            colnames(M_imp) <- colnames(x_num)
            M_imp[,pref[1]] <- 1
            
            ordVWR_type1 <- (-I*Avg) + (M_imp*Avg[pref[1]])
            ordVWR_type1 <- ordVWR_type1[-which(colnames(M_imp)==pref[1]),]
            
            ### OrdVWR_type2
            I2 = diag(x = 1, n_indic)
            colnames(I2) <- colnames(x_num)
            I2[,pref[length(pref)]] <- 0
            
            M_imp2 =  matrix(0,nrow=(n_indic), ncol=n_indic)
            colnames(M_imp2) <- colnames(x_num)
            rownames(M_imp2) <- colnames(x_num)
            M_imp2[,which(colnames(M_imp2)==pref[length(pref)])] <- -Avg[pref[length(pref)]]
            ordVWR_type2 <- (I2*Avg)+ M_imp2
            colnames(ordVWR_type2) <- colnames(x_num)
            rownames(ordVWR_type2) <- colnames(x_num)
            
            #'%!in%' <- function(x,y)!('%in%'(x,y))
            #ordVWR_type2 <- ordVWR_type2[-which(colnames(ordVWR_type2) %!in% pref),]
            ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[length(pref)]),]
            ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[1]),]
            
            Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
            Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
            
            f.con <- rbind(Constr1, Constr2, Pweight_g, Pweight_b, VWRg, ordVWR_type1, ordVWR_type2)
            jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
            score[i] <- jj$objval
            w[i, ] <- rbind(jj$solution)
            final[i, ] <- c(score[i], w[i, ])
            
    # Case 3: the preference vector has a number of elements >2 and < of the number of indicators 
    }
      if(length(pref)>2 & length(pref)<n_indic){
      
            f.obj <- c(f.sign * x_num[i, ])
            
            f.dir <- c("==",rep(">=", times = n_unit), rep(">=", times = g+b), 
                       rep(">=",times=(n_indic-1)), rep(">=",times=(p-2)), 
                       rep(">=", times = g+b))
            
            f.rhs <- c(1, rep(0, times = n_unit), rep(0, times = g+b), 
                       rep(0,times=(n_indic-1)), rep(0, times = (p-2)),
                       rep(0, times = g+b))  
            
            Constr1 <- c(x_num[i,])
            Constr2 <- cbind(t(f.sign * t(x_num))) 
            
            I = diag(x = 1, n_indic)
            VWRg = t((I - low_w)*as.vector(Avg)) 
            
            ### OrdVWR_type1
            I = diag(x = 1, n_indic)
            colnames(I) <- colnames(x_num)
            I[,pref[1]] <- 0
            
            M_imp =  matrix(0,nrow=(n_indic), ncol=n_indic)
            colnames(M_imp) <- colnames(x_num)
            M_imp[,pref[1]] <- 1
            
            ordVWR_type1 <- (-I*Avg) + (M_imp*Avg[pref[1]])
            ordVWR_type1 <- ordVWR_type1[-which(colnames(M_imp)==pref[1]),]
            
            ### OrdVWR_type2
            I2 = diag(x = 1, n_indic)
            colnames(I2) <- colnames(x_num)
            I2[,pref[length(pref)]] <- 0
            
            M_imp2 =  matrix(0,nrow=(n_indic), ncol=n_indic)
            colnames(M_imp2) <- colnames(x_num)
            rownames(M_imp2) <- colnames(x_num)
            M_imp2[,which(colnames(M_imp2)==pref[length(pref)])] <- -Avg[pref[length(pref)]]
            ordVWR_type2 <- (I2*Avg)+ M_imp2
            colnames(ordVWR_type2) <- colnames(x_num)
            rownames(ordVWR_type2) <- colnames(x_num)
            
            '%!in%' <- function(x,y)!('%in%'(x,y))
            ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2) %!in% pref),]
            ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[length(pref)]),]
            ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[1]),]
            
            Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
            Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
            
            f.con <- rbind(Constr1, Constr2, Pweight_g, Pweight_b, VWRg, ordVWR_type1, ordVWR_type2)
            jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
            score[i] <- jj$objval
            w[i, ] <- rbind(jj$solution)
            final[i, ] <- c(score[i], w[i, ])
    }
 }else{
      f.obj <- c(f.sign * x_num[i, ])
      
      f.dir <- c("==",rep(">=", times = n_unit), rep(">=", times = g+b), 
                 rep(">=", times = g+b))
      f.rhs <- c(1, rep(0, times = n_unit), rep(0, times = g+b), 
                 rep(0, times = g+b))  
      
      Constr1 <- c(x_num[i,])
      Constr2 <- cbind(t(f.sign * t(x_num)))
      
      I = diag(x = 1, n_indic)
      VWRg = t((I - low_w)*as.vector(Avg)) 
      Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
      Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
      
      f.con <- rbind(Constr1, Constr2, VWRg, Pweight_g, Pweight_b)
      jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
      score[i] <- jj$objval
      w[i, ] <- rbind(jj$solution)
      final[i, ] <- c(score[i], w[i, ])
    }
  }
  eff <- (1/(1+score))
  
  colnames(w) <- colnames(x_num)
  
  # Write the composite scores and the indicator target values in one result matrix
  
  target <- matrix(nrow=n_unit,ncol=(b+g)) 
  for(j in 1:g)
  {
  target[,j] <- x_num[,j] + (Avg[j]*score)
  }
  for(j in (g+1):(g+b))
  {
    target[,j] <- x_num[,j] - (Avg[j]*score)
  }
  colnames(target) <- colnames(x_num)
  
  r <- list(ci_bod_constr_bad_est = eff, ci_bod_constr_bad_weights = w, 
            ci_bod_constr_bad_target = target, ci_method = "bod_constr_bad")
  r$call <- match.call()
  class(r) <- "CI"
  r
}

ci_factor <- function(x,indic_col, method="ONE", dim=3)
{
#   library(psych)
#   library(GPArotation)
  x_num   = x[,indic_col]
  n_indic <- dim(x_num)[2]
  n_unit <- dim(x_num)[1]
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }  

  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }    
  
  
  
  if (method=="ONE") 
  {
    fit <- psych::principal(x_num, nfactors = 1, scores=TRUE)
    pesi_fatt = as.matrix(colSums(fit$loading*fit$loading)/n_indic) 
    ci_factor_est = fit$scores
    biplot(fit)
    
    r<-list(ci_factor_est=ci_factor_est, loadings_fact=pesi_fatt, ci_method="factor")
    r$call<-match.call()
    class(r)<-"CI"
    return(r)
  
  }
  if (method=="ALL") 
  {
    fit <- psych::principal(x_num, nfactors = n_indic, scores=TRUE)
    pesi_fatt = as.matrix(colSums(fit$loading*fit$loading)/n_indic)    
    ci_factor_est = fit$scores %*% pesi_fatt

    biplot(fit)
    
    r<-list(ci_factor_est=ci_factor_est, loadings_fact=pesi_fatt, ci_method="factor")
    r$call<-match.call()
    class(r)<-"CI"
    return(r)
  }
  if (method=="CH") 
  {
    fit <- psych::principal(x_num, nfactors = dim, scores=TRUE)
    biplot(fit)
    pesi_fatt = as.matrix(colSums(fit$loading*fit$loading)/n_indic) 
    pesi_fatt = pesi_fatt[1:dim]
    fit$scores = fit$scores[,1:dim]
    ci_factor_est = fit$scores %*% pesi_fatt
    r<-list(ci_factor_est=ci_factor_est, loadings_fact=pesi_fatt, ci_method="factor")
    r$call<-match.call()
    class(r)<-"CI"
    return(r)
  }
    if (method!="ONE" & method!="ALL" & method!="CH")
  {
    stop("Please check method!") 
  }   
}

plot_M_robust_ci <- function(x,indic_col,method,mvector,B,dir,interval=NULL)
{
  x_num   = x[,indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  } 
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }  
  
  uni <- as.matrix(seq(1, 1, len = dim(x_num)[1]))
  ci_data = cbind(x_num, uni)
  
  msuper <- matrix(0, nrow = length(mvector), ncol = 1)
  
  for (m in 1:length(mvector)) {
    if(method=="rbod")
    {
      scores <- ci_rbod(x, indic_col, M=mvector[m],B=B)$ci_rbod_est
      msuper[m,1] <- length(scores[scores >= 1])/nrow(ci_data)
    }
    if(method=="rbod_dir")
    {
      scores <- ci_rbod_dir(x, indic_col, M=mvector[m],B=B, dir=dir)$ci_rbod_dir_est
      msuper[m,1] <- length(scores[scores >= 1])/nrow(ci_data)
    }
    if(method=="rbod_mdir")
    {
      scores <- ci_rbod_mdir(ci_data, M=mvector[m],B=B,interval=interval)$ci_rbod_mdir_est
      msuper[m,1] <- length(scores[scores > 1])/nrow(ci_data)
    }
  }
  
  plot(x = mvector, y = msuper[, 1], type = "b", lwd = 2, main = "Percentage of outperforming units by subset size M", 
       xlab = c("M"), ylab = c("% of outperforming units"), 
       ylim = c(min(msuper), max(msuper)))
  graphics::lines(x = mvector, y = msuper[, 1], type = "b", 
                  lwd = 2)
  
}

ci_wroclaw <- function(x,indic_col)
{
  options(warn=-1)
  x_num   = x[,indic_col]
  n_indic <- dim(x_num)[2]
  n_unit  <- dim(x_num)[1]  
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }    
  
  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }  
  
  #passo 2
  Ma <- matrix(0, nrow=1, ncol=n_indic)
  for (i in seq(1,n_indic)) 
  {
    Ma[i] <- max(x_num[,i], na.rm=TRUE)
  }
  #Ma <- apply(x_num,2,max)
  Ma_m <- t(matrix(Ma, nrow=n_indic, ncol=n_unit))
  
  #passo 3
  diff_Ma = x_num - Ma_m
  
  #passo 4
  diff_Ma_q = diff_Ma^2
  
  #passo 5
  Sum_riga <- as.matrix(apply(diff_Ma_q,1,sum))
  
  # passo 6
  Sum_riga_rad <- Sum_riga^0.5
  
  # passo 7
  media = mean(Sum_riga_rad, na.rm=TRUE)
  std   = (var(Sum_riga_rad, na.rm=TRUE))^0.5
  div <- t(matrix(media + 2*std, nrow=1, ncol=n_unit))
  ci_wroclaw_est = Sum_riga_rad / div

  r<-list(ci_wroclaw_est=ci_wroclaw_est, ci_method="wroclaw")
  r$call<-match.call()
  class(r)<-"CI"
  return(r)
  
}

ci_bod <- function(x,indic_col)
{
  #library(Benchmarking)
  x_num   = x[,indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  } 
  
   for (i in seq(1,n_unit)) 
   {
     for (j in seq(1,n_indic)) 
     {
     if (is.na(x_num[i,j]))
     {
       message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
#       options(warn=-2)  
     }
     }
   }  
  
  ci_data = as.matrix(cbind(x_num))
  uni <- as.matrix(seq(1, 1, len = dim(ci_data)[1]))
  CI <- Benchmarking::dea.dual(uni,ci_data,ORIENTATION=1,RTS=3)
  #Peers = peers(CI)
  Lambda = CI$v
  
  r<-list(ci_bod_est=CI$eff,ci_bod_weights = Lambda, ci_method="bod")
  r$call<-match.call()
  class(r)<-"CI"
  r
    
  ##return(ci_bod_est)
}

ci_mpi <- function(x, indic_col, penalty="POS")
{
  x_num   = x[,indic_col]  
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit  <- dim(as.matrix(x_num))[1]
  
  # Warning
  
  message("Pay attention: This function was rewritten in version 3.2 of this package; it is now necessary to normalise simple data BEFORE using the function; see the example in the help. ")
 
  
  # Numeric check
  if (n_indic<2)
  {
    stop(paste("There must be at least two simple indicators!"))
  }
  
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }   

  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }  
  
    
  
  #punto A
  #Ma <- colMeans(x_num) 
  #Sqm <- (apply(x_num,2,var))^0.5
  #S=10
  #M=100
  #z = ((x_num-Ma)/Sqm)*S + M  
  
  #punto B
  #Ma_z <- apply(z,1,mean)
  #Sqm_z <- (apply(z,1,var))^0.5
  #cv = Sqm_z / Ma_z
  
  Ma_z <- apply(x_num,1,mean)
  Sqm_z <- (apply(x_num,1,var))^0.5
  cv = Sqm_z / Ma_z
  
  #punto C
  if (penalty=="POS") {
    ci_mpi_est <- Ma_z*(1-cv^2) 
  } else {
    ci_mpi_est <- Ma_z*(1+cv^2)
  }

  r<-list(ci_mpi_est=ci_mpi_est, ci_method="mpi")
  r$call<-match.call()
  class(r)<-"CI"
  return(r)

  
}

ci_geom_gen <- function(x,indic_col,meth,up_w,low_w,bench)
{

  x_num   = x[,indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  rowProds <- function(X){ apply(X,1,FUN="prod") }
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  } 
  
   for (i in seq(1,n_unit)) 
   {
     for (j in seq(1,n_indic)) 
     {
     if (is.na(x_num[i,j]))
     {
       message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
#       options(warn=-2)  
     }
     }
   }  
  
  
  
  if (meth=="EQUAL")  {
    
    geom_BoD = rowProds(x_num ^ (1/n_indic) )
    
    r<-list(ci_mean_geom_est=geom_BoD, ci_method="mean_geom")
    r$call<-match.call()
    class(r)<-"CI"
    r
    
  }
  
  
  if (meth=="BOD")  {  
    
  app = ci_bod_constr(x_num,indic_col,up_w,low_w)
  w = app$ci_bod_constr_weights

  
  # Normalising by benchmark unit vector
  x_num_norm = sweep(x_num, 2, t(x_num[bench,]), "/",check.margin=FALSE)
  
  # calculation data_norm * weights
  mult_BoD = rowProds(x_num_norm ^ w)

  r<-list(ci_geom_bod_est=mult_BoD,
          ci_geom_bod_weights = w, 
          ci_method="geometric_bod")
  r$call<-match.call()
  class(r)<-"CI"
  r
}

r
}

ci_mean_min <- function(x, indic_col, alpha, beta)
{
  x_num   = x[,indic_col]  
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit  <- dim(as.matrix(x_num))[1]
  
  # Numeric check
  if (n_indic<2)
  {
    stop(paste("There must be at least two simple indicators!"))
  }
  if (alpha>1)
  {
    stop(paste("Alpha must be set >=0 and <=1!"))
  }
  if (alpha<0)
  {
    stop(paste("Alpha must be set >=0 and <=1!"))
  }
  if (beta<0)
  {
    stop(paste("Beta must be set >=0!"))
  }
  
  
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }   

  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }  
  

  #punto A
  Ma <- colMeans(x_num) 
  Sqm <- (apply(x_num,2,var))^0.5
  S=10
  M=100
  z = ((x_num-Ma)/Sqm)*S + M
  
  #punto B
  Ma_z <- apply(z,1,mean)
  min_col <- apply(z,1,min)
  part = ((Ma_z - min_col)^2+beta^2)^0.5
  MMF = Ma_z - alpha * (part - beta)
  
  r<-list(ci_mean_min_est=MMF, ci_method="mean_min")
  r$call<-match.call()
  class(r)<-"CI"
  return(r)

}

ci_bod_constr <- function(x,indic_col,up_w,low_w)
{

  x_num   = x[,indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  } 
  
   for (i in seq(1,n_unit)) 
   {
     for (j in seq(1,n_indic)) 
     {
     if (is.na(x_num[i,j]))
     {
       message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
#       options(warn=-2)  
     }
     }
   }  
  

  #library(lpSolve)
  x_num = as.matrix(x_num)

  
  soluz <- rep(0, times=n_unit)
  eff   <- cbind(matrix(0, nrow=n_unit, ncol=(n_indic)))
  final <- cbind(matrix(0, nrow=n_unit, ncol=(n_indic+1)))
  
  for (i in 1:n_unit) 
  {  
    f.obj   <- x_num[i,]
    f.dir   <- c(rep("<=",times=n_unit), rep(">=",times=(n_indic+n_indic)),rep(">=",times=(n_indic)))
    f.rhs   <- c(rep(1,times=n_unit), rep(0,times=(n_indic+n_indic)), rep(0,times=(n_indic)))
    nconstr <- x_num
    Pweight <- cbind(diag(1, nrow=n_indic,ncol=n_indic))
    
    ####### Contraints 
    I = diag(x = 1, n_indic)
    upper = - I+up_w
    lower =  I-low_w
    d3_up  = t(as.vector(f.obj)*upper)
    d3_low = t(as.vector(f.obj)*lower)
    d3 = rbind(d3_up,d3_low)
    ####### End Contraints 
    
    f.con <- rbind(nconstr,d3, Pweight)
    jj <- lp("max", f.obj, f.con, f.dir, f.rhs)
    soluz[i] <- jj$objval
    eff[i,] <- rbind(jj$solution)
    final[i,] <- c(soluz[i], eff[i,])
  }    
  
  w <- ((eff * x_num)/soluz)

  r<-list(ci_bod_constr_est=soluz,
          ci_bod_constr_weights = w, 
          ci_method="bod_constrained")
  r$call<-match.call()
  class(r)<-"CI"
  r
    
  ##return(ci_bod_constr_est)
}

ci_owa <- function(x, id, indic_col,atleastjp)
{
  x_num = x[, indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  for (i in seq(1, n_indic)) {
    if (!is.numeric(x_num[, i])) {
      stop(paste("Data set not numeric at column:", i))
    }
  }
  for (i in seq(1, n_unit)) {
    for (j in seq(1, n_indic)) {
      if (is.na(x_num[i, j])) {
        message(paste("Pay attention: NA values at column:", 
                      i, ", row", j, ". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
      }
    }
  }
  ci_data = as.matrix(cbind(x_num))
  
  
  #######################################################
  #########                 OWA                 #########
  #######################################################
  ### transpose
  rownames(ci_data) <- x[,id] 
  indic_t <- as.data.frame(t(ci_data))
  
  rows<-n_indic
  cols<-n_unit
  
  ### order each column separately without consider the indicator 
  data_ord <- data.frame(1:n_indic,
                         matrix(NA,ncol=n_unit, nrow=n_indic))
  for(i in 1:n_unit)
  {
    data_ord[,i+1]<- sort(indic_t[,i], decreasing = TRUE)
  }
  colnames(data_ord)<- c(id,colnames(indic_t))
  
  data_ord2<- data_ord[,-1]
  
  #######################################################
  
  n=rows
  alfap=atleastjp/n
  wp <- c(rep(0,n-atleastjp),rep(1/atleastjp,atleastjp))
  wn <- c(rep(1/atleastjp,atleastjp),rep(0,n-atleastjp))
  CI_OWA_p<- matrix(NA, ncol=1, nrow=cols)
  CI_OWA_n<- matrix(NA, ncol=1, nrow=cols)
  
  for(c in 1:cols)
  {
    CI_OWA_n[c,] <- sum(data_ord2[,c]*wp) #more than j
    CI_OWA_p[c,] <- sum(data_ord2[,c]*wn) #at least j
  }
  
  r<- list(CI_OWA_n=CI_OWA_n, CI_OWA_p=CI_OWA_p, wp=wp, wn=wn, ci_method = "owa")
  r$call <- match.call()
  class(r) <- "CI"
  r
}  

ci_bod_var_w <- function(x,indic_col,boot_rep = 5000)
{
#   library(Hmisc)
#   library(lpSolve)
#   library(nonparaeff)
#   library(boot)
  
  boot_r = boot_rep
  x_num   = x[,indic_col]
  n_indic = dim(x_num)[2]
  n_unit  = dim(x_num)[1]
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }  
  
  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }   
  
  
  # lower and higher variance confidence limits #################
  low_var  = matrix(0, nrow=n_indic, ncol=1)
  high_var = matrix(0, nrow=n_indic, ncol=1)
  for (i in seq(1,n_indic)) 
  {
    bootcorr <- boot(x_num[,i], var, R=boot_r)
    interv_var = boot.ci(bootcorr, conf = 0.95, type="norm")
    low_var[i]  = interv_var$normal[2]
    high_var[i] = interv_var$normal[3]
  }
  
  for (i in seq(1,n_indic)) 
  {
    if (low_var[i]<=0) {
      stop("Warning: Lower confidence bound negative!") 
    } 
  }
  
  # lower and higher ratio matrices ############################
  conf_low = matrix(0, nrow=n_indic, ncol=n_indic)
  for (i in seq(1,n_indic)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (i<j)
      { 
        conf_low[i,j] = low_var[i] / high_var[j]
      }
    }
  }
  
  conf_high = matrix(0, nrow=n_indic, ncol=n_indic)
  for (i in seq(1,n_indic)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (i<j)
      { 
        conf_high[i,j] = high_var[i] / low_var[j]
      }
    }
  }
  
  ## Caricamento matrice restriction weights ################
  
  num_righe_weights = ((n_indic*n_indic)-n_indic)/2
  ## (LEFT lower bounds)
  left_low = matrix(0, nrow=num_righe_weights, ncol=n_indic)
  riga = 0
  for (i in seq(1,n_indic)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (conf_low[i,j]>0)
      { 
        riga = riga + 1
        left_low[riga,i] =1
        left_low[riga,j] =-conf_low[i,j]
      }
    }
  }
  
  ## (LEFT higher bounds)
  left_high = matrix(0, nrow=num_righe_weights, ncol=n_indic)
  riga = 0
  for (i in seq(1,n_indic)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (conf_high[i,j]>0)
      { 
        riga = riga + 1
        left_high[riga,i] =-1
        left_high[riga,j] =conf_high[i,j]
      }
    }
  }
  
  # LEFT - Colonna di zero per l'input unitario
  left_zero = matrix(0, nrow=num_righe_weights*2, ncol=1)
  
  #LEFT - Matrice complessiva
  left_low_high = rbind(left_low,left_high)
  left          = cbind(left_low_high,left_zero)
  
  #RIGHT - condizioni di zero
  right = matrix(0, nrow=num_righe_weights*2, ncol=1)
  
  #CONDIZIONE
  dir = matrix(">=", nrow=num_righe_weights*2, ncol=1)
  
  ########  creazione input unitario
  uni <- as.matrix(seq(1, 1, len = n_unit))
  data_per_bod = cbind(x_num,uni)
  
  CI = ar.dual.dea(data_per_bod, noutput = n_indic, orientation = 2, rts = 1, 
                   ar.l = left, 
                   ar.r = right,
                   ar.dir = dir)
  
  ci_bod_var_w_est = 1/CI[[1]]
  
  r<-list(ci_bod_var_w_est=ci_bod_var_w_est, ci_method="bod_var_w")
  r$call<-match.call()
  class(r)<-"CI"
  r
  
}

ci_rbod_spatial <- function(x, indic_col, M=20, B=100, W) 
{
  
  x_num   = x[,indic_col]
  n_indic = dim(x_num)[2]
  n_unit  = dim(x_num)[1]

  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }    
  
  
  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }      
  
  ###################################
  
  W = as.matrix(W)
  #library(spdep)
  nb <- mat2listw(W, row.names = NULL, style="M")$neighbours
  
  uni <- as.matrix(seq(1, 1, len = n_unit))
  data_per_spRbod = cbind(x_num,uni)
  
  dim = dim(x)[1]
  eff_cond = matrix(NA, nrow=dim, ncol=1)
  
  
  for (i in (1:dim)) {
    
    dati_front_cond = data_per_spRbod[c(nb[[i]]),]
    dati_order_riga = data_per_spRbod[i,]
    rbod_cond = try(orderm(base = dati_order_riga, 
                           frontier = dati_front_cond, 
                           noutput = n_indic, 
                           orientation=2, M = M, B = B))
    if ('try-error' %in% class(rbod_cond)) next
    eff_cond[i] = 1/rbod_cond$eff
  }
  r <- list(ci_rbod_spatial_est = eff_cond, 
            ci_method = "rbod_spatial")
}

ci_generalized_mean <- function(x, indic_col, p, na.rm=TRUE)
{
 # library(psych)
  x_num   = x[,indic_col]
  n_indic <- dim(x_num)[2]
  n_unit  <- dim(x_num)[1]
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }   

  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }   
  
    
  
  t_x = t(x_num)
  
  if (!na.rm) {
    x_elev_p = x_num^p
    sum_p = apply(x_elev_p,1,sum)
    ci_generalized_mean_est = (1/n_indic*sum_p)^1/p
    
  } else {
    ci_generalized_mean_est <- 1 #### CAMBIARE
  }
  
  r<-list(ci_generalized_mean_est=ci_generalized_mean_est, ci_method="generalized_mean")
  r$call<-match.call()
  class(r)<-"CI"
  return(r)
  
}

ci_rbod_dir <- function (x, indic_col, M = 25, B = 500, dir) 
{

 # require(lpSolve)
  dataset   = x[,indic_col]
  n_indic <- dim(dataset)[2]
  n_unit <- dim(dataset)[2]
  s <- dim(dataset)[2]
  m <- ncol(dataset) - s
  n <- nrow(dataset)
  #dir_m=matrix(dir,nrow(dataset),n_indic,byrow=TRUE)
  dir_m=matrix(dir,1,n_indic,byrow=TRUE)
  dataset <- as.matrix(dataset)
  
  # Numeric check

  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(dataset[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    #  options(warn=-1) 
    }
  }
 
    
    
    for (i in seq(1,n_unit)) 
    {
      for (j in seq(1,n_indic)) 
      {
        if (is.na(dataset[i,j]))
        {
          message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
          #       options(warn=-2)  
        }
      }
    }  
    
    
      
  
  dataset.Y <- as.matrix(dataset[, 1:s]) #* dir_m
  dataset.X <- as.matrix(seq(1, 1, len = n)) 
  re <- matrix(0, nrow = n, ncol = 1)
  
  for (i in 1:n) {
    
    eff <- matrix(0,nrow=B,ncol=1)
    y0 <- dataset.Y[i,] * dir_m 
    x0 <- dataset.X[i,] 
    for (b in 1:B) {
      
      dataset.idx.y = dataset.Y
      
      # Selezione soggetti con y maggiore del punto
      selez = as.matrix(apply(dataset.X <= x0,1,min))        
      dataset.idx.y = data.frame(selez, dataset.idx.y)
      dataset.idx.y <- dataset.idx.y[selez==1,]
      
      # sample
      
      
      dataset.idx.m  <-dataset.idx.y[sample(nrow(dataset.idx.y), M, replace = TRUE),-1]
      
      # distanza euclidea punto - m peers
      mat <- as.matrix(dataset.idx.m/matrix(y0,nrow(dataset.idx.m),2,byrow=TRUE))
      eff[b] <- max(apply(mat, 1, min)) 
      
    }
    re[i] = 1/mean(eff)
  }
    
  r<-list(ci_rbod_dir_est=re, ci_method="rbod_dir")
  r$call<-match.call()
  class(r)<-"CI"
  return(r)
}




 

ci_rbod_constr_bad <- function (x, indic_col, ngood=1, nbad=1, low_w=0, pref=NULL, M, B) 
{
  x_num = x[, indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  for (i in seq(1, n_indic)) {
    if (!is.numeric(x_num[, i])) {
      stop(paste("Data set not numeric at column:", i))
    }
  }
  for (i in seq(1, n_unit)) {
    for (j in seq(1, n_indic)) {
      if (is.na(x_num[i, j])) {
        message(paste("Pay attention: NA values at column:", 
                      i, ", row", j, ". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
      }
    }
  }
  if(!is.null(pref)){
    if (!is.character(pref)) {
      stop(paste("The preference vector (pref) is not of character type"))
    }
  }
  if(n_indic!=(ngood+nbad)){
    stop(paste("The number of simple indicators is not equal to the sum of the
               number of good and bad outputs, please insert the right number
               of simple indicators in x or choose the right number of columns
               in indic_col or indicate the right number of good and bad outputs
               in ngood and nbad."))
  }
  if(ngood==0){
    stop(paste("The number of good outputs (ngood) has to be greater than 0."))
  }
  if(nbad==0){
    stop(paste("The number of bad outputs (nbad) has to be greater than 0."))
  }
  
  
  x_num = as.matrix(x_num)
  
  pref <- pref
  
  g <- ngood
  b <- nbad
  p <- length(pref)

  Avg <- apply(x_num, 2, mean)
  
  score <- rep(0, times = n_unit)
  eff <- rep(0, times = n_unit)
  w <- cbind(matrix(0, nrow = n_unit, ncol = (n_indic)))
  final <- cbind(matrix(0, nrow = n_unit, ncol = (1+n_indic)))
  
  f.sign <- c(rep(-1, g), rep(1, b))
  
  for (i in 1:n_unit) {
    
    if(!is.null(pref))
    {
    score_B <- matrix(nrow=B,ncol=1)
    w_B <- cbind(matrix(0, nrow = B, ncol = (n_indic)))
    final_B <- cbind(matrix(0, nrow = B, ncol = (1+n_indic)))
    fl <- seq(1:n_unit)
    k <- 1
    
    for(k in 1:B)
    {
      draw <- sample(fl, size=M, replace=TRUE)
      x_num_sample <- x_num[draw,]
      
      # Different cases of ordVWR
      # Case 1: the preference vector has only 2 elements => only ordVWR_type1  
      if(length(pref)==2)
      {
      
          f.obj <- c(f.sign * x_num[i, ])
          
          f.dir <- c("==",rep(">=", times = M), rep(">=", times = g+b), 
                     rep(">=",times=(n_indic-1)),
                     rep(">=", times = g+b))
          
          f.rhs <- c(1, rep(0, times = M), rep(0, times = g+b), 
                     rep(0,times=(n_indic-1)),
                     rep(0, times = g+b))  
          
          Constr1 <- c(x_num[i,])
          Constr2 <- cbind(t(f.sign * t(x_num_sample))) 
          
          I = diag(x = 1, n_indic)
          VWRg = t((I - low_w)*as.vector(Avg)) 
          
          ### OrdVWR_type1
          I = diag(x = 1, n_indic)
          colnames(I) <- colnames(x_num)
          I[,pref[1]] <- 0
          
          M_imp =  matrix(0,nrow=(n_indic), ncol=n_indic)
          colnames(M_imp) <- colnames(x_num)
          M_imp[,pref[1]] <- 1
          
          ordVWR_type1 <- (-I*Avg) + (M_imp*Avg[pref[1]])
          ordVWR_type1 <- ordVWR_type1[-which(colnames(M_imp)==pref[1]),]
          
          ### OrdVWR_type2
          I2 = diag(x = 1, n_indic)
          colnames(I2) <- colnames(x_num)
          I2[,pref[length(pref)]] <- 0
          
          M_imp2 =  matrix(0,nrow=(n_indic), ncol=n_indic)
          colnames(M_imp2) <- colnames(x_num)
          M_imp2[,which(colnames(M_imp)==pref[length(pref)])] <- -Avg[pref[length(pref)]]
          ordVWR_type2 <- (I2*Avg)+ M_imp2
          
          '%!in%' <- function(x,y)!('%in%'(x,y))
          ordVWR_type2 <- ordVWR_type2[-which(colnames(M_imp) %!in% pref),]
          ordVWR_type2 <- ordVWR_type2[-which(colnames(M_imp)==pref[1]),]
          ordVWR_type2 <- ordVWR_type2[-which(colnames(M_imp)==pref[length(pref)]),]
          
          
          Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
          Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
          
          f.con <- rbind(Constr1, Constr2, Pweight_g, Pweight_b, VWRg, ordVWR_type1)
          
          jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
          score_B[k] <- jj$objval
          w_B[k, ] <- rbind(jj$solution)
          final_B[k, ] <- c(score_B[k], w_B[k, ])
      }
      
    # Case 2: the preference vector has all indicators         
    
    if(length(pref)==n_indic){    
      
        f.obj <- c(f.sign * x_num[i, ])
        
        f.dir <- c("==",rep(">=", times = M), rep(">=", times = g+b), 
                   rep(">=",times=(n_indic-1)), rep(">=",times=(p-2)),
                   rep(">=", times = g+b))
        
        f.rhs <- c(1, rep(0, times = M), rep(0, times = g+b), 
                   rep(0,times=(n_indic-1)), rep(0,times=(p-2)),
                   rep(0, times = g+b))  
        
        Constr1 <- c(x_num[i,])
        Constr2 <- cbind(t(f.sign * t(x_num_sample))) 
        
        I = diag(x = 1, n_indic)
        VWRg = t((I - low_w)*as.vector(Avg)) 
        
        ### OrdVWR_type1
        I = diag(x = 1, n_indic)
        colnames(I) <- colnames(x_num)
        I[,pref[1]] <- 0
        
        M_imp =  matrix(0,nrow=(n_indic), ncol=n_indic)
        colnames(M_imp) <- colnames(x_num)
        M_imp[,pref[1]] <- 1
        
        ordVWR_type1 <- (-I*Avg) + (M_imp*Avg[pref[1]])
        ordVWR_type1 <- ordVWR_type1[-which(colnames(M_imp)==pref[1]),]
        
        ### OrdVWR_type2
        I2 = diag(x = 1, n_indic)
        colnames(I2) <- colnames(x_num)
        I2[,pref[length(pref)]] <- 0
        
        M_imp2 =  matrix(0,nrow=(n_indic), ncol=n_indic)
        colnames(M_imp2) <- colnames(x_num)
        rownames(M_imp2) <- colnames(x_num)
        M_imp2[,which(colnames(M_imp2)==pref[length(pref)])] <- -Avg[pref[length(pref)]]
        ordVWR_type2 <- (I2*Avg)+ M_imp2
        colnames(ordVWR_type2) <- colnames(x_num)
        rownames(ordVWR_type2) <- colnames(x_num)
        
        #'%!in%' <- function(x,y)!('%in%'(x,y))
        #ordVWR_type2 <- ordVWR_type2[-which(colnames(ordVWR_type2) %!in% pref),]
        ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[length(pref)]),]
        ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[1]),]
        
        Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
        Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
        
        f.con <- rbind(Constr1, Constr2, Pweight_g, Pweight_b, VWRg, ordVWR_type1, ordVWR_type2)
        
        jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
        score_B[k] <- jj$objval
        w_B[k, ] <- rbind(jj$solution)
        final_B[k, ] <- c(score_B[k], w_B[k, ])
    }
    
    # Case 3: the preference vector has a number of elements >2 and < of the number of indicators 
      
      if(length(pref)>2 & length(pref)<n_indic){
    
        f.obj <- c(f.sign * x_num[i, ])
        
        f.dir <- c("==",rep(">=", times = M), rep(">=", times = g+b), 
                   rep(">=",times=(n_indic-1)), rep(">=",times=(p-2)),
                   rep(">=", times = g+b))
        
        f.rhs <- c(1, rep(0, times = M), rep(0, times = g+b), 
                   rep(0,times=(n_indic-1)), rep(0,times=(p-2)),
                   rep(0, times = g+b))  
        
        Constr1 <- c(x_num[i,])
        Constr2 <- cbind(t(f.sign * t(x_num_sample))) 
        
        I = diag(x = 1, n_indic)
        VWRg = t((I - low_w)*as.vector(Avg)) 
        
        ### OrdVWR_type1
        I = diag(x = 1, n_indic)
        colnames(I) <- colnames(x_num)
        I[,pref[1]] <- 0
        
        M_imp =  matrix(0,nrow=(n_indic), ncol=n_indic)
        colnames(M_imp) <- colnames(x_num)
        M_imp[,pref[1]] <- 1
        
        ordVWR_type1 <- (-I*Avg) + (M_imp*Avg[pref[1]])
        ordVWR_type1 <- ordVWR_type1[-which(colnames(M_imp)==pref[1]),]
        
        ### OrdVWR_type2
        I2 = diag(x = 1, n_indic)
        colnames(I2) <- colnames(x_num)
        I2[,pref[length(pref)]] <- 0
        
        M_imp2 =  matrix(0,nrow=(n_indic), ncol=n_indic)
        colnames(M_imp2) <- colnames(x_num)
        rownames(M_imp2) <- colnames(x_num)
        M_imp2[,which(colnames(M_imp2)==pref[length(pref)])] <- -Avg[pref[length(pref)]]
        ordVWR_type2 <- (I2*Avg)+ M_imp2
        colnames(ordVWR_type2) <- colnames(x_num)
        rownames(ordVWR_type2) <- colnames(x_num)
        
        '%!in%' <- function(x,y)!('%in%'(x,y))
        ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2) %!in% pref),]
        ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[length(pref)]),]
        ordVWR_type2 <- ordVWR_type2[-which(rownames(ordVWR_type2)==pref[1]),]
        
        Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
        Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
        
        f.con <- rbind(Constr1, Constr2, Pweight_g, Pweight_b, VWRg, ordVWR_type1, ordVWR_type2)
        
        jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
        score_B[k] <- jj$objval
        w_B[k, ] <- rbind(jj$solution)
        final_B[k, ] <- c(score_B[k], w_B[k, ])
      }
    }
  }else{
    score_B <- matrix(nrow=B,ncol=1)
    w_B <- cbind(matrix(0, nrow = B, ncol = (n_indic)))
    final_B <- cbind(matrix(0, nrow = B, ncol = (1+n_indic)))
    fl <- seq(1:n_unit)
    k <- 1
    
    for(k in 1:B)
    {
      draw <- sample(fl, size=M, replace=TRUE)
      x_num_sample <- x_num[draw,]
      
      f.obj <- c(f.sign * x_num[i, ])
      
      f.dir <- c("==",rep(">=", times = M), rep(">=", times = g+b), 
                 rep(">=", times = g+b))
      f.rhs <- c(1, rep(0, times = M), rep(0, times = g+b), 
                 rep(0, times = g+b))  
      
      Constr1 <- c(x_num[i,])
      Constr2 <- cbind(t(f.sign * t(x_num_sample))) 
      
      I = diag(x = 1, n_indic)
      VWRg = t((I - low_w)*as.vector(Avg)) 
      Pweight_g <- cbind(diag(1, nrow = g, ncol = g), matrix(0,nrow=g,ncol=b))
      Pweight_b <- cbind(matrix(0,nrow=b,ncol=g),diag(1, nrow = b, ncol = b))
      
      f.con <- rbind(Constr1, Constr2, VWRg, Pweight_g, Pweight_b)
      jj <- lp("min", f.obj, f.con, f.dir, f.rhs)
      score_B[k] <- jj$objval
      w_B[k, ] <- rbind(jj$solution)
      final_B[k, ] <- c(score_B[k], w_B[k, ])
    }
  }    
   score[i]<- apply(score_B,2,mean) 
   w[i,]<- apply(w_B,2,mean)  
   final[i,]<- apply(final_B,2,mean)  
  }
  eff <- (1/(1+score))
  
  colnames(w) <- colnames(x_num)
  
  # Write the composite scores and the indicator target values in one result matrix
  
  target <- matrix(nrow=n_unit,ncol=(b+g)) 
  for(j in 1:g)
  {
    target[,j] <- x_num[,j] + (Avg[j]*score)
  }
  for(j in (g+1):(g+b))
  {
    target[,j] <- x_num[,j] - (Avg[j]*score)
  }
  colnames(target) <- colnames(x_num)
  
  r <- list(ci_rbod_constr_bad_est = eff, ci_rbod_constr_bad_weights = w, 
            ci_rbod_constr_bad_target = target, ci_method = "rbod_constr_bad")
  r$call <- match.call()
  class(r) <- "CI"
  r
}

ci_bod_time_decomp <- function(data_long,
                               id_col,
                               time_col,
                               indic_cols) {
  
  stopifnot(is.data.frame(data_long))
  stopifnot(all(c(id_col, time_col, indic_cols) %in% names(data_long)))
  
  df <- data_long
  df <- df[order(df[[time_col]], df[[id_col]]), ]
  
  times <- unique(df[[time_col]])
  times <- sort(times)
  
  if (length(times) < 2) {
    stop("At least two time periods are required to compute the dynamic decomposition.")
  }
  
  if (anyDuplicated(data_long[, c(id_col, time_col)])) {
    stop("Each unit-time combination must appear only once in 'data_long'.")
  }
  
  run_bod <- function(d) {
    X  <- d[, indic_cols, drop = FALSE]
    CI <- ci_bod(X, indic_col = seq_len(ncol(X)))
    as.numeric(CI$ci_bod_est)
  }
  
  # 1) contemporaneous
  E_C <- rep(NA_real_, nrow(df))
  for (tt in times) {
    idx <- which(df[[time_col]] == tt)
    E_C[idx] <- run_bod(df[idx, , drop = FALSE])
  }
  
  # 2) sequential
  E_S <- rep(NA_real_, nrow(df))
  for (tt in times) {
    idx_ref <- which(df[[time_col]] <= tt)
    idx_t   <- which(df[[time_col]] == tt)
    
    scores_ref   <- run_bod(df[idx_ref, , drop = FALSE])
    pos_t_in_ref <- which(df[idx_ref, time_col] == tt)
    E_S[idx_t] <- scores_ref[pos_t_in_ref]
  }
  
  # 3) intertemporal
  E_I <- run_bod(df)
  
  out <- data.frame(
    id   = df[[id_col]],
    time = df[[time_col]],
    E_C  = E_C,
    E_S  = E_S,
    E_I  = E_I
  )
  
  out <- out[order(out$id, out$time), ]
  
  lag1 <- function(x) c(NA_real_, x[-length(x)])
  
  E_C_lag <- ave(out$E_C, out$id, FUN = lag1)
  E_S_lag <- ave(out$E_S, out$id, FUN = lag1)
  
  # 1. Total Change Index (TC)
  out$TotalChange <- out$E_C / E_C_lag
  
  # 2. Catch-up Index (CU)
  out$CatchUp <- out$E_S / E_S_lag
  
  # 3. Benchmark Shift Index (BS)
  frontier_units <- list()
  for (tt in times) {
    idx <- which(out$time == tt & abs(out$E_C - 1) < 1e-6)
    if (length(idx) > 0) {
      frontier_units[[as.character(tt)]] <- out[idx, ]
    }
  }
  
  out$BenchmarkShift <- NA_real_
  
  for (i in 2:length(times)) {
    t_curr <- times[i]
    t_prev <- times[i - 1]
    
    curr_frontier <- frontier_units[[as.character(t_curr)]]
    prev_frontier <- frontier_units[[as.character(t_prev)]]
    
    if (!is.null(curr_frontier) &&
        !is.null(prev_frontier) &&
        nrow(curr_frontier) > 0 &&
        nrow(prev_frontier) > 0) {
      
      curr_ids <- curr_frontier$id
      prev_ids <- prev_frontier$id
      
      curr_data <- df[df[[time_col]] == t_curr &
                        df[[id_col]] %in% curr_ids,
                      indic_cols, drop = FALSE]
      
      prev_data <- df[df[[time_col]] == t_prev &
                        df[[id_col]] %in% prev_ids,
                      indic_cols, drop = FALSE]
      
      if (nrow(curr_data) > 0 && nrow(prev_data) > 0) {
        curr_means <- colMeans(curr_data, na.rm = TRUE)
        prev_means <- colMeans(prev_data, na.rm = TRUE)
        
        ratios <- curr_means / prev_means
        out$BenchmarkShift[out$time == t_curr] <- mean(ratios, na.rm = TRUE)
      }
    }
  }
  
  out$BenchmarkShift[out$time == times[1]] <- NA_real_
  
  return(out)
}

ci_factor_mixed <- function (x, indic_col, method = "ONE", dim = 3) {
  
  #library(FactoMineR)
  x_num   = x[,indic_col]
  n_indic <- length(indic_col)
  n_unit <- nrow(x)

  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }    
  
  
  
  if (method == "ONE") {
    famd_results <- FAMD(x[, indic_col], ncp = 1, graph = FALSE)
    pesi_fatt = as.matrix(var(famd_results$ind$coord)^2)
    ci_factor_est = famd_results$ind$coord
    r <- list(ci_factor_est = ci_factor_est, loadings_fact = pesi_fatt, 
              ci_method = "factor_mixed")
    
  } else if (method == "ALL") {
    # Make sure that ncp is not greater than min(n_unit-1, n_indic)
    ncp_to_use <- min(n_unit - 1, n_indic)
    famd_results <- FAMD(x[, indic_col], ncp = ncp_to_use, graph = FALSE)
    # Calculate the weights for each factor
    pesi_fatt = apply(famd_results$var$coord^2, 2, sum) / ncp_to_use
    # Compute the composite indicator scores
    ci_factor_est = famd_results$ind$coord %*% pesi_fatt
    r <- list(ci_factor_est = ci_factor_est, loadings_fact = pesi_fatt, 
              ci_method = "factor_mixed")
    
  } else if (method == "CH") {
    famd_results <- FAMD(x[, indic_col], ncp = dim, graph = FALSE)
    pesi_fatt = apply(famd_results$var$coord^2, 2, sum) / n_indic
    pesi_fatt = pesi_fatt[1:dim]
    ci_factor_est = famd_results$ind$coord[, 1:dim] %*% pesi_fatt
    r <- list(ci_factor_est = ci_factor_est, loadings_fact = pesi_fatt, 
              ci_method = "factor_mixed")
  } else {
    stop("Please check method!")
  }
  
  r$call <- match.call()
  class(r) <- "CI"
  return(r)
}

ci_bod_mdir <- function(x,indic_col)
{
  x_num   = x[,indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  } 
  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }  
  
  ci_data = as.matrix(cbind(x_num))
  uni <- as.matrix(seq(1, 1, len = dim(ci_data)[1]))
  den_CImeaSPEC = cbind(matrix(0, nrow = n_unit, ncol = (n_indic)))
  CImeaSPEC = cbind(matrix(0, nrow = n_unit, ncol = (n_indic)))
    
  CI <- mea(uni,ci_data,  ORIENTATION = "out", RTS="crs")
  
  for (j in seq(1,n_indic)) 
  {
  den_CImeaSPEC[,j] <-ci_data[,j]+((CI$eff)*CI$direct[,j])
  CImeaSPEC[,j] <- ci_data[,j]/den_CImeaSPEC[,j]
  }
  
  ci_mdir_est <- 1-rowSums((CI$direct*CI$eff)/rowSums(ci_data+((CI$eff)*CI$direct)))
  
  r<-list(ci_bod_mdir_est=ci_mdir_est,ci_bod_mdir_spec=CImeaSPEC, ci_bod_mdir_dir = CI$direct, ci_method="bod_mdir")
  r$call<-match.call()
  class(r)<-"CI"
  r
}

ci_bod_dir <- function(x,indic_col,dir)
{
#   library(Benchmarking)
#   library(MASS)
#   library(Hmisc)
  
  x_num   = x[,indic_col]
  ci_data = as.matrix(cbind(x_num))
  ci_data_dir= as.matrix(cbind(x_num))
  n_indic = dim(x_num)[2]
  n_unit  = dim(x_num)[1]
  uni <- as.matrix(seq(1, 1, len = n_unit))
  
  # Numeric check
  for (i in seq(1,n_indic)) 
  {
    if (!is.numeric(x_num[,i]))
    {
      stop(paste("Data set not numeric at column:",i))
    }
  }
  
  
  for (i in seq(1,n_unit)) 
  {
    for (j in seq(1,n_indic)) 
    {
      if (is.na(x_num[i,j]))
      {
        message(paste("Pay attention: NA values at column:",i,", row",j,". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
        #       options(warn=-2)  
      }
    }
  }  
  

  
  for (i in seq(1,n_indic)) 
       {
           ci_data_dir[,i] = ci_data[,i] * dir[i]
       }
    
  ci_dir  = Benchmarking::dea(uni,ci_data,RTS="crs", ORIENTATION="out", DIRECT=dir)
  ci_bod_dir_est = 1/(ci_dir$eff + 1)
  
  r<-list(ci_bod_dir_est=ci_bod_dir_est, ci_method="bod_dir")
  r$call<-match.call()
  class(r)<-"CI"
  r
  
}

ci_rbod_mdir <- function (x, indic_col, M, B, interval = 0.05) 
{
  confidence_interval <- function(vector, interval) {
    vec_sd <- sd(vector, na.rm = TRUE)
    n <- length(vector[!is.na(vector)])
    vec_mean <- mean(vector, na.rm = TRUE)
    error <- suppressWarnings(qt((interval + 1)/2, df = n - 1) * vec_sd/sqrt(n))
    result <- c(lower = vec_mean - error, upper = vec_mean + 
                  error)
    return(result)
  }
  x_num = x[, indic_col]
  rownames(x_num)<- 1:dim(x_num)[1]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  if (n_unit <= M) {
    stop("M is greater than or equal to the number of total units")
  }
  for (i in seq(1, n_indic)) {
    if (!is.numeric(x_num[, i])) {
      stop(paste("Data set not numeric at column:", i))
    }
  }
  for (i in seq(1, n_unit)) {
    for (j in seq(1, n_indic)) {
      if (is.na(x_num[i, j])) {
        message(paste("Pay attention: NA values at column:", 
                      i, ", row", j, ". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
      }
    }
  }
  ci_mdir_est <- matrix(nrow = B, ncol = M)
  ci_mdir_est_exact <- matrix(nrow = B, ncol = n_unit)
  conf <- matrix(nrow = 2, ncol = n_unit)
  CImeaSPEC_tot <- matrix(0, nrow = n_unit, ncol = n_indic)
  CIdirecttot <- matrix(0, nrow = n_unit, ncol = n_indic)
  list_dir1 <- c()
  list_dir2 <- c()
  for (k in 1:B) {
    ci_data = as.matrix(x_num[sample(nrow(x_num), M), ])
    units = as.numeric(row.names(ci_data))
    uni <- as.matrix(seq(1, 1, len = dim(ci_data)[1]))
    den_CImeaSPEC = cbind(matrix(0, nrow = M, ncol = (n_indic)))
    CImeaSPEC = cbind(matrix(0, nrow = M, ncol = (n_indic)))
    CI <- mea(uni, ci_data, ORIENTATION = "out", RTS = "crs")
    for (j in seq(1, n_indic)) {
      den_CImeaSPEC[, j] <- ci_data[, j] + ((CI$eff) * 
                                              CI$direct[, j])
      CImeaSPEC[, j] <- ci_data[, j]/den_CImeaSPEC[, j]
    }
    ci_mdir_est[k, ] <- 1 - rowSums((CI$direct * CI$eff)/rowSums(ci_data + 
                                                                   ((CI$eff) * CI$direct)))
    
    for (z in 1:M) {
      ci_mdir_est_exact[k, units[z]] = ci_mdir_est[k, z]
      for (j in seq(1, n_indic)) {
        CImeaSPEC_tot[units[z], j] = CImeaSPEC[z, j]
        CIdirecttot[units[z], j] = CI$direct[z, j]
      }
      list_dir1[[k]] <- CImeaSPEC_tot
      list_dir2[[k]] <- CIdirecttot
    }
    cat(paste("\f", "Loop:", k, "of total", B,"\n"))
  }
  
  for (k in 1:B) {
    row <- ci_mdir_est_exact[k,]
    ord <- sort(row, decreasing = TRUE)
    distances <- diff(ord)
    threshold <- quantile(distances, 0.90, na.rm = TRUE)
    outlier_idx <- which(distances > threshold)
    ci_mdir_est_exact[k, outlier_idx] <- 1.5
  }
  
  E_ci_mdir_est = colMeans(ci_mdir_est_exact, na.rm = TRUE)
  for (w in 1:n_unit) {
    conf[, w] = confidence_interval(ci_mdir_est_exact[, w], 
                                    0.95)
  }
  CImeaSPEC_tot = mat_mean(list_dir1, na.rm = TRUE)
  CIdirecttot = mat_mean(list_dir2, na.rm = TRUE)
  r <- list(ci_rbod_mdir_est = E_ci_mdir_est, conf = t(rbind(lower_ci = conf[1, 
  ], upper_ci = conf[2, ])), ci_rbod_mdir_spec = CImeaSPEC_tot, 
  ci_rbod_mdir_dir = CIdirecttot, ci_method = "rbod_mdir")
  r$call <- match.call()
  class(r) <- "CI"
  r
}

bandwidth_CI <- function(x, indic_col, ngood, nbad, Q=NULL, Q_ord=NULL)
{
  x_num = x[, indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  for (i in seq(1, n_indic)) {
    if (!is.numeric(x_num[, i])) {
      stop(paste("Data set not numeric at column:", i))
    }
  }
  for (i in seq(1, n_unit)) {
    for (j in seq(1, n_indic)) {
      if (is.na(x_num[i, j])) {
        message(paste("Pay attention: NA values at column:", 
                      i, ", row", j, ". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
      }
    }
  }

  
  x_num = as.matrix(x_num)
  
  g <- ngood
  b <- nbad
  
  if(!is.null(Q) & is.null(Q_ord)){ 
    Q = as.matrix(Q)
    number_exogenous <- dim(Q)[2]
    nq_cont <- dim(Q)[2]
    nq_ord  <- 0
  }
  
  if(is.null(Q) & !is.null(Q_ord)){ 
    Q_ord = as.matrix(Q_ord)
    number_exogenous <- dim(Q_ord)[2]
    nq_cont <- 0
    nq_ord  <- dim(Q_ord)[2]
  }
  
  if(!is.null(Q) & !is.null(Q_ord)){ 
    Q = as.matrix(Q)
    Q_ord = as.matrix(Q_ord)
    number_exogenous <- dim(Q)[2] + dim(Q_ord)[2] 
    nq_cont <- dim(Q)[2]
    nq_ord  <- dim(Q_ord)[2]
  }
  
  # Create (n x (b+g)) matrix with only FALSE-values
flag_ii<-matrix(FALSE,nrow=length(x_num[,1]),ncol=(b+g))
# Flag all data values which satisfy the conditions below with TRUE-values

flag_gi <- apply(matrix(x_num[,1:g],ncol=g), 2, function(x) x<=median(x))
flag_bi <- apply(matrix(x_num[,(g+1):(g+b)],ncol=b), 2, function(x) x>=median(x))
flag_ii <- cbind(flag_gi,flag_bi)

# Flag the NUTS II regions which satisfy the (b+g) conditions
flagg <- matrix(nrow=length(x_num[,1]),ncol=1)
for (j in (1:length(x_num[,1])))
{
  flagg[j] <- all(flag_ii[j,])
}
# Flag for the observations who satisfy all criteria the data and exogenous variables with TRUE-values 
if(!is.null(Q) & is.null(Q_ord)){ 
  flag_QQ <- subset(Q,subset=flagg,drop=TRUE)   # the continuous exogenous variables
  data_fr1 <- data.frame(flag_QQ)
}

if(is.null(Q) & !is.null(Q_ord)){ 
  flag_ordd <- subset(Q_ord,subset=flagg,drop=TRUE)  # the discrete (ordered) exogenous variables
  data_fr1 <- data.frame(apply(flag_ordd, 2, ordered))
}

if(!is.null(Q) & !is.null(Q_ord)){ 
  flag_QQ <- subset(Q,subset=flagg,drop=TRUE)   # the continuous exogenous variables
  flag_ordd <- subset(Q_ord,subset=flagg,drop=TRUE)  # the discrete (ordered) exogenous variables
  # Collect the concerned data in a dataframe
  data_fr1 <- data.frame(flag_QQ,apply(flag_ordd, 2, ordered))
}

flag_yy <- subset(x_num,subset=flagg,drop=TRUE)   # the performance variables

# Compute the bandwiths using the performance data and exogenous data
bw1 <-  npcdensbw(ydat=flag_yy,xdat=data_fr1,cykertype="epanechnikov",cxkertype="epanechnikov",bwmethod="cv.ls",oxkertype="liracine",itmax = 1000)   ##set itmax to 1000 nmulti to 4 and tol high
# Take the bandwiths for the exogenous variables
bwfull <- bw1$xbw

# Create an empty (nx1)-matrix
aha<- matrix(nrow=length(x_num[,1]),ncol=1)
# Create an empty matrix to store the endogenous bandwiths for the exogenous variables
bw_cx <- matrix(nrow=length(x_num[,1]),ncol=number_exogenous)
# Set i equal to the start value 1 (start loop with DMU 1)
i <- 1
# Define the loop to indicate which NUTS II regions dominate region i
for (i in (1:length(x_num[,1])))
{
  #Define a (n x (b+g)) matrix with all FALSE values
  flag_i<-matrix(FALSE,nrow=length(x_num[,1]),ncol=(b+g))
  # Flag the data values that dominate the values of DMU i
  flag_g <- apply(matrix(x_num[,1:g],ncol=g), 2, function(x) x<=x[i])
  flag_b <- apply(matrix(x_num[,(g+1):(g+b)],ncol=b), 2, function(x) x>=x[i])
  flag_i <- cbind(flag_g,flag_b)
  #Define a (n x 1) matrix 
  flag <- matrix(nrow=length(x_num[,1]),ncol=1)
  # Define a loop to indicate which NUTS II-regions dominate region i
  for (j in (1:length(x_num[,1])))
  {
    flag[j] <- all(flag_i[j,])
  }
  # print(i)
  # Take the subset of data values that correspond to the flagged NUTS II-regions 

  # Flag for the observations who satisfy all criteria the data and exogenous variables with TRUE-values 
  if(!is.null(Q) & is.null(Q_ord)){ 
    flag_Q <- matrix(subset(Q,subset=flag,drop=TRUE), ncol=nq_cont)   # the continuous exogenous variables
    # Collect the concerned data (continuous and discrete exogenous variables and performance data of dominating regions) in a dataframe 
    data_fr <- data.frame(flag_Q)
  }
  
  if(is.null(Q) & !is.null(Q_ord)){ 
    flag_ord <- matrix(subset(Q_ord,subset=flag,drop=TRUE), ncol=nq_ord)  # the discrete (ordered) exogenous variables
    # Collect the concerned data (continuous and discrete exogenous variables and performance data of dominating regions) in a dataframe 
    data_fr <- data.frame(apply(flag_ord, 2, ordered))
  }
  
  if(!is.null(Q) & !is.null(Q_ord)){ 
    flag_Q <- matrix(subset(Q,subset=flag,drop=TRUE), ncol=nq_cont)   # the continuous exogenous variables
    flag_ord <-  matrix(subset(Q_ord,subset=flag,drop=TRUE), ncol=nq_ord)  # the discrete (ordered) exogenous variables
    # Collect the concerned data (continuous and discrete exogenous variables and performance data of dominating regions) in a dataframe 
    data_fr <- data.frame(flag_Q,apply(flag_ord, 2, ordered))
  }
  
  flag_y <- subset(x_num,subset=flag,drop=TRUE)      # the performance variables
  
  #print(sum(flag))     # display the number of NUTS-regions dominating region i
  aha[i]=sum(flag)
  # Define a loop to determine the proper bandwith based on the number of dominating regions
  if((sum(flag))<=40)               # if number of dominating regions lower than or equal to threshold
  {
    bw_cx[i,] <-bwfull              # bandwith equal to what was derived endogenously above
  } else
  {                               # if number of dominating regions higher than threshold

    # Compute the bandwiths using the performance data and exogenous data
    bw <-  npcdensbw(ydat=flag_y,xdat=data_fr,cykertype="epanechnikov",cxkertype="epanechnikov",bwmethod="cv.ls",oxkertype="liracine",itmax = 10000,nmulti=4)   ##set itmax to 1000 nmulti to 4 and tol high
    # Take the bandwiths for the exogenous variables
    bw_cx[i,] <- bw$xbw
    #      print(bw_cx[i,])
  }
}

# save the output of the first step
#write.matrix(bw_cx, file = "welbandwidth.txt", sep ="\t")

# before opening the .txt file, first reset the options for system separators
# Open the file with the endogenously estimated bandwiths (for the exogenous variables)
#bw_cx<-read.table("welbandwidth.txt", sep = "\t")
bw_cx2=bw_cx
# Adjust the estimated bandwiths for the discrete (ordered) exogenous variables
if(!is.null(Q) & is.null(Q_ord)){ 
  bw_cx2 <- bw_cx
}

if(is.null(Q) & !is.null(Q_ord)){ 
  bw_cx2[apply(bw_cx, 2, function(x) x>0.9999999)]<-0.9999
}

if(!is.null(Q) & !is.null(Q_ord)){ 
  bw_cx2[,nq_cont+1:(nq_cont+nq_ord-2)][apply(bw_cx[,nq_cont+1:(nq_cont+nq_ord-2)], 2, function(x) x>0.9999999)]<-0.9999
}

# Specify the final version of the matrix with endogenous bandwiths
bw_cx<-bw_cx2

#write.matrix(bw_cx, file = "welbandwidth_adj.txt", sep ="\t")

r <- list(bandwidth = bw_cx,ci_method = "bandwidth_CI")
r$call <- match.call()
class(r) <- "CI"
r

}

# ampi with penality and normalized data

ci_ampi <- function (x, indic_col, gp, time, polarity, penalty = "NEG") 
{
  x_num = x[, indic_col]
  n_indic <- dim(as.matrix(x_num))[2]
  n_unit <- dim(as.matrix(x_num))[1]
  if (n_indic < 2) {
    stop(paste("There must be at least two simple indicators!"))
  }
  for (i in seq(1, n_indic)) {
    if (!is.numeric(x_num[, i])) {
      stop(paste("Data set not numeric at column:", i))
    }
  }
  for (i in seq(1, n_unit)) {
    for (j in seq(1, n_indic)) {
      if (is.na(x_num[i, j])) {
        message(paste("Pay attention: NA values at column:", 
                      i, ", row", j, ". Composite indicator has been computed, but results may be misleading, Please refer to OECD handbook, pg. 26."))
      }
    }
  }
  timef = levels(as.factor(time))
  penalty <- matrix(0, nrow = (n_unit/length(timef)), ncol = length(timef))
  norm <- list()
  ci_ampi_est <- matrix(0, nrow = (n_unit/length(timef)), ncol = length(timef))
  for (t in 1:length(timef)) {
    x_num_t <- x_num[time == timef[t], ]
    ci_norm <- x_num_t
    max <- matrix(0, nrow = 1, ncol = n_indic)
    min <- matrix(0, nrow = 1, ncol = n_indic)
    delta <- matrix(0, nrow = 1, ncol = n_indic)
    minim <- matrix(0, nrow = 1, ncol = length(gp))
    maxim <- matrix(0, nrow = 1, ncol = length(gp))
    min = apply(x_num, 2, function(x) min(x, na.rm = TRUE))
    max = apply(x_num, 2, function(x) max(x, na.rm = TRUE))
    delta = (max - min)/2
    maxim = gp + delta
    minim = gp - delta
    for (i in seq(1, n_indic)) {
      if (polarity[i] == "POS") {
        ci_norm[, i] = (((x_num_t[, i]) - minim[i])/(maxim[i] - 
                                                       minim[i])) * 60 + 70
      }
      if (polarity[i] == "NEG") {
        ci_norm[, i] = ((maxim[i] - (x_num_t[, i]))/(maxim[i] - 
                                                       minim[i])) * 60 + 70
      }
      if (polarity[i] != "NEG" & polarity[i] != "POS") {
        stop("Please check polarity!")
      }
    }
    norm[[t]] <- ci_norm
    Ma_z <- apply(ci_norm, 1, mean)
    Sqm_z <- (apply(ci_norm, 1, function(x) {var(x)*(length(x)- 1)/length(x)}))^0.5
    cv = Sqm_z/Ma_z
    penalty[,t] <- (Sqm_z * cv)
    ifelse(penalty == "POS", ci_ampi_est[,t] <- round(Ma_z + penalty[,t], 3), ci_ampi_est[, t] <- round(Ma_z - penalty[,t], 3))
  }
  ci_ampi_est <- as.data.frame(ci_ampi_est)
  penalty <- as.data.frame(penalty)
  colnames(ci_ampi_est) <- timef
  r <- list(ci_ampi_est = ci_ampi_est, ci_method = "ampi", ci_penalty=penalty, ci_norm=norm)
  r$call <- match.call()
  class(r) <- "CI"
  return(r)
}

\name{ci_bod}
\alias{ci_bod}
\title{Benefit of the Doubt approach (BoD)}
\description{Benefit of the Doubt approach (BoD) is the application of Data Envelopment Analysis (DEA) to the field of composite indicators. It was originally proposed by Melyn and Moesen (1991) to evaluate macroeconomic performance.}
%"\emph{The Benefit of the Doubt approach is formally tantamount to the original input-oriented Data Envelopment Analysis with Constant Returns to Scale (CRS-DEA) model of Charnes et al. (1978), with all questionnaire items considered as outputs and a dummy input equal to one for all observations}", Witte and Rogge (2009).

\usage{ci_bod(x,indic_col)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
}

%\details{Please pay attention that \emph{"weights are not uniquely determined. Note also that the multiplicity of solutions is likely to depend %upon the set of constraints imposed on the weights of the maximisation problem, the wider the range of variation of weights, the lower the %possibility of obtaining a unique solution"}, OECD (2008).}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_bod_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="bod".}
  \item{ci_bod_weights}{Raw weights assigned to the simple indicators (Dual values - prices - in the dual DEA formulation).}
}

\references{

OECD (2008) "\emph{Handbook on constructing composite indicators: methodology and user guide}".

Melyn W. and Moesen W.W. (1991) "\emph{Towards a synthetic indicator of macroeconomic performance: unequal weighting when limited information is available}", Public Economic research Paper 17, CES, KU Leuven.

Witte, K. D., Rogge, N. (2009) "\emph{Accounting for exogenous influences in a benevolent performance evaluation of teachers}". Tech. rept. Working
Paper Series ces0913, Katholieke Universiteit Leuven, Centrum voor Economische Studien.
}

\author{Vidoli F.}

\seealso{ \code{\link{ci_bod_dir}},\code{\link{ci_rbod}} }

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_bod(Indic)
 # validating BoD score
w = CI$ci_bod_weights
Indic[,1]*w[,1] + Indic[,2]*w[,2]


data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),polarity = c("POS","POS"), method=2)
CI = ci_bod(data_norm$ci_norm,c(1:2))
}

\name{ci_bod_dir}
\alias{ci_bod_dir}
\title{Directional Benefit of the Doubt (D-BoD) model}
\description{Directional Benefit of the Doubt (D-BoD) model enhance non-compensatory property by introducing directional penalties in a standard BoD model in order to consider the preference structure among simple indicators.}

\usage{ci_bod_dir(x, indic_col, dir)}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
   \item{indic_col}{Simple indicators column number.}
  \item{dir}{Main direction. For example you can set the average rates of substitution.}  
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_bod_dir_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="bod_dir".}
}


%\details{ 
%   INSERIRE FUNZIONE CHE CALCOLA TRAMITE ACP
%}

\references{Fusco E. (2015) "\emph{Enhancing non compensatory composite indicators: A directional proposal}", European Journal of Operational Research, 242(2), 620-630.}

\author{Vidoli F., Fusco E.}

\seealso{ \code{\link{ci_bod}}, \code{\link{ci_rbod}}}

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_bod_dir(Indic,dir=c(1,1))

data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),polarity = c("POS","POS"), method=2)
CI = ci_bod_dir(data_norm$ci_norm,c(1:2),dir=c(1,0.5))
}

\name{bandwidth_CI}
\alias{bandwidth_CI}

\title{Multivariate mixed bandwidth selection for exogenous variables}

\description{A function for the selection of optimal multivariate mixed bandwidths for the kernel
density estimation of continuous and discrete exogenous variables.}

\usage{bandwidth_CI(x, indic_col, ngood, nbad, Q=NULL, Q_ord=NULL)}

\arguments{
  \item{x}{A data frame containing simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{ngood}{The number of desirable outputs; it has to be greater than 0.}
  \item{nbad}{The number of undesirable  outputs; it has to be greater than 0.}
  \item{Q}{A matrix containing continuous exogenous variables.}
  \item{Q_ord}{A matrix containing discrete exogenous variables.}
}


\value{
  \item{bandwidth}{A matrix containing the optimal bandwidths for the exogenous variables indicate in Q and Q_ord.}
  \item{ci_method}{"bandwidth_CI}
}

\details{Author thanks Nicky Rogge for his help and for making available the original code of the bandwidth function.}

\author{Fusco E., Rogge N.}

%\seealso{ \code{\link{ci_bod}}, \code{\link{ci_mpi}}}

\examples{
data(EU_2020)
indic <- c("employ_2011", "gasemiss_2011","deprived_2011")  
dat   <- EU_2020[-c(10,18),indic]
Q_GDP <- EU_2020[-c(10,18),"percGDP_2011"]

# Conditional robust BoD Constrained VWR
band = bandwidth_CI(dat, ngood=1, nbad=2, Q = Q_GDP)
}

\name{ci_bod_time_decomp}
\alias{ci_bod_time_decomp}

\title{Dynamic Benefit of the Doubt decomposition for panel data}

\description{
Computes dynamic Benefit of the Doubt (BoD) composite indicator scores for
panel data using contemporaneous, sequential and intertemporal reference
technologies. The function also computes Total Change, Catch-Up and Benchmark
Shift indices.
}

\usage{
ci_bod_time_decomp(
  data_long,
  id_col,
  time_col,
  indic_cols
)
}

\arguments{

  \item{data_long}{
  A data frame in long format containing the panel data.
  }

  \item{id_col}{
  Character string identifying the column containing the unit identifiers.
  }

  \item{time_col}{
  Character string identifying the column containing the time variable.
  }

  \item{indic_cols}{
  Character vector specifying the indicator variables used to compute the
  Benefit of the Doubt composite indicator.
  }
}

\details{

For each period the function computes three BoD efficiency scores:

\itemize{
  \item contemporaneous scores (\code{E_C});
  \item sequential scores (\code{E_S});
  \item intertemporal scores (\code{E_I}).
}

These scores are then used to compute:

\itemize{
  \item Total Change (\code{TotalChange});
  \item Catch-Up (\code{CatchUp});
  \item Benchmark Shift (\code{BenchmarkShift});
}
}

\value{

A data frame containing:

\itemize{
  \item \code{id}: unit identifier;
  \item \code{time}: time period;
  \item \code{E_C}: contemporaneous BoD score;
  \item \code{E_S}: sequential BoD score;
  \item \code{E_I}: intertemporal BoD score;
  \item \code{TotalChange}: Total Change index;
  \item \code{CatchUp}: Catch-Up index;
  \item \code{BenchmarkShift}: Benchmark Shift index.
}
}

\references{

Fusco, E. and Magrini, A. (2026) 
\emph{Dynamic Benefit of the Doubt Decomposition for Panel Data: Evidence from Sustainable Energy in the EU}.
Sustainability, 18, 5835.
}

\author{
E.Fusco and A.Magrini
}

\seealso{
\code{\link{ci_bod}}
}

\examples{

panel <- data.frame(
  id = rep(1:3, each = 4),
  time = rep(1:4, times = 3),
  I1 = c(
    0.40, 0.43, 0.47, 0.52,
    0.60, 0.63, 0.67, 0.72,
    0.80, 0.84, 0.89, 0.95
  ),
  I2 = c(
    0.50, 0.54, 0.58, 0.63,
    0.70, 0.74, 0.79, 0.84,
    0.90, 0.95, 1.00, 1.06
  )
)

res <- ci_bod_time_decomp(
  data_long = panel,
  id_col = "id",
  time_col = "time",
  indic_cols = c("I1", "I2")
)

#head(res)

}

\name{ci_factor_mixed}
\alias{ci_factor_mixed}
\title{Weighting method based on Factor analysis of mixed data (FAMD)}

\description{Factor analysis of mixed data (FAMD) can be seen as a principal component method dedicated to analyze a data set containing both quantitative and qualitative variables making possible to compute composite indicators taking into account continous, dummy, or factor variables}

\usage{
ci_factor_mixed(x,indic_col,method="ONE",dim)
}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{method}{If method = "ONE" (default) the composite indicator estimated values are equal to first component scores; if method = "ALL" the composite indicator estimated values are equal to component score multiplied by its proportion variance;  if method = "CH" it can be choose the number of the component to take into account.}
  \item{dim}{Number of chosen component (if method = "CH", default is 3).}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_factor_est}{Composite indicator estimated values.}
  \item{loadings_fact}{Variance explained by principal factors (in percentage terms).}
  \item{ci_method}{Method used; for this function ci_method="factor_mixed".}
}


\author{Luis Carlos Castillo Tellez}

\seealso{ \code{\link{ci_bod}}, \code{\link{ci_factor}}}

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
i3 <- seq(0, 1, len = 100)
i3 = as.factor(ifelse(i3>0.5,1,0))
Indic = data.frame(i1, i2, i3)

CI  = ci_factor_mixed(Indic,c(1:3))
CI2 = ci_factor_mixed(Indic,c(1:3), method="ALL")
CI3 = ci_factor_mixed(Indic,c(1:3), method="CH", dim=2)
}

\name{ci_rbod_constr_bad_Q}
\alias{ci_rbod_constr_bad_Q}
\title{Conditional robust constrained Benefit of the Doubt approach (BoD) in presence of undesirable  indicators}
\description{The Conditional robust constrained Benefit of the Doubt function introduces additional constraints to the weight variation in the optimization procedure (Constrained Virtual Weights Restriction) allowing to restrict the importance attached to a single indicator expressed in percentage terms, ranging between a lower and an upper bound (VWR); this function, furthermore, allows to calculate the composite indicator simultaneously in presence of undesirable (bad) and desirable (good) indicators allowing to impose a preference structure (ordVWR). This function, in addition to being robust against outlier data (see \code{ci_rbod_constr_bad} function) allows to take into account external contextual continuous (\code{Q}) or/and ordinal (\code{Q_ord}) variables.}

\usage{ci_rbod_constr_bad_Q(x, indic_col, ngood=1, nbad=1, 
low_w=0, pref=NULL, M, B, Q=NULL, Q_ord=NULL, bandwidth)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
    \item{ngood}{The number of desirable outputs; it has to be greater than 0.}
  \item{nbad}{The number of undesirable  outputs; it has to be greater than 0.}
  \item{low_w}{Importance weights lower bound.}
  \item{pref}{The preference vector among indicators; For example if \code{Indic1} is the most important, \code{Indic2},\code{Indic3} are more important than \code{Indic4} and no preference judgment on \code{Indic5} (= not included in the vector), the \code{pref} vector can be written as: \code{c("Indic1", "Indic2","Indic3","Indic4")}}
  \item{M}{The number of elements in each of the bootstrapped samples.}
  \item{B}{The number of bootstrap replicates.}
  \item{Q}{A matrix containing continuous exogenous variables.}
  \item{Q_ord}{A matrix containing discrete exogenous variables.}
  \item{bandwidth}{Multivariate mixed bandwidth for exogenous variables; it can be calculated by \code{bandwidth_CI} function.}
  
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_rbod_constr_bad_Q_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="rbod_constr_bad_Q".}
  \item{ci_rbod_constr_bad_Q_weights}{Raw weights assigned to each simple indicator.}
  \item{ci_rbod_constr_bad_Q_target}{Indicator target values.}
}

\references{
Rogge N., de Jaeger S. and Lavigne C. (2017) "\emph{Waste Performance of NUTS 2-regions in the EU: A Conditional Directional Distance Benefit-of-the-Doubt Model}", Ecological Economics, vol.139, pp. 19-32.

Zanella A., Camanho A.S. and Dias T.G. (2015) "\emph{Undesirable outputs and weighting schemes in composite indicators based on data envelopment analysis}", European Journal of Operational Research, vol. 245(2), pp. 517-530.
}

\author{Fusco E., Rogge N.}

\seealso{ \code{\link{ci_rbod_constr_bad}}, \code{\link{ci_bod_constr_bad}} }



\examples{
#data(EU_2020)

#indic <- c("employ_2011", "gasemiss_2011","deprived_2011")  
#dat   <- EU_2020[-c(10,18),indic]
#Q_GDP <- EU_2020[-c(10,18),"percGDP_2011"]

# Conditional robust BoD Constrained VWR
#band = bandwidth_CI(dat, ngood=1, nbad=2, Q = Q_GDP)

#CI_BoD_C = ci_rbod_constr_bad_Q(dat, 
#                                ngood=1, 
#                                nbad=2, 
#                                low_w=0.05, 
#                                pref=NULL, 
#                                M=10, 
#                                B=50, 
#                                Q=Q_GDP, 
#                                bandwidth = band$bandwidth)
#CI_BoD_C$ci_rbod_constr_bad_Q_est


# # Conditional robust BoD Constrained ordVWR
# import <- c("gasemiss_2011","employ_2011", "deprived_2011")
# 
# CI_BoD_C2 = ci_rbod_constr_bad_Q(dat, 
#                                  ngood=1, 
#                                  nbad=2, 
#                                  low_w=0.05, 
#                                  pref=import, 
#                                  M=10, 
#                                  B=50, 
#                                  Q=Q_GDP, 
#                                  bandwidth = band$bandwidth)
# CI_BoD_C2$ci_rbod_constr_bad_Q_est
}

\name{ci_factor}
\alias{ci_factor}
\title{Weighting method based on Factor Analysis}

\description{Factor analysis groups together collinear simple indicators to estimate a composite indicator that captures as much as possible of the information common to individual indicators.}

\usage{
ci_factor(x,indic_col,method="ONE",dim)
}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{method}{If method = "ONE" (default) the composite indicator estimated values are equal to first component scores; if method = "ALL" the composite indicator estimated values are equal to component score multiplied by its proportion variance;  if method = "CH" it can be choose the number of the component to take into account.}
  \item{dim}{Number of chosen component (if method = "CH", default is 3).}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_factor_est}{Composite indicator estimated values.}
  \item{loadings_fact}{Variance explained by principal factors (in percentage terms).}
  \item{ci_method}{Method used; for this function ci_method="factor".}
}

\references{OECD (2008) "\emph{Handbook on constructing composite indicators: methodology and user guide}".}

\author{
  Vidoli F.
}

\seealso{ \code{\link{ci_bod}}, \code{\link{ci_mpi}}}

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_factor(Indic)

data(EU_NUTS1)
CI = ci_factor(EU_NUTS1,c(2:3), method="ALL")

data(EU_2020)
data_norm = normalise_ci(EU_2020,c(47:51),polarity = c("POS","POS","POS","POS","POS"), method=2)
CI3 = ci_factor(data_norm$ci_norm,c(1:5),method="CH", dim=3)
}

\name{EU_2020}
\alias{EU_2020}
\title{Europe 2020 indicators}
\description{Europe 2020, a strategy for jobs and smart, sustainable and inclusive growth, is based on five EU headline targets which are currently measured by eight headline indicators, Headline indicators, Eurostat, year 1990-2012 (Last update:	21/11/2013).

For more info, please see \url{https://ec.europa.eu/eurostat/en/web/products-statistics-in-focus/-/KS-SF-12-039}.
}
\usage{data(EU_2020)}

\format{EU_2020 is a dataset with 30 observations and 12 indicators (190 indicator per year).

\describe{
	\item{geo}{EU-Member States including EU (28 countries) and EU (27 countries) row.}	
    \item{employXXXX}{Employment rate - age group 20-64, year XXXX (1992-2012).}	
    \item{perc_GDPXXXX}{Gross domestic expenditure on R&D (GERD), year XXXX (1990-2012).}
    \item{gas_emissXXXX}{Greenhouse gas emissions - base year 1990, year XXXX (1990-2011).}
	\item{share_renXXXX}{Share of renewable energy in gross final energy consumption, year XXXX (2004-2011).}
	\item{prim_enerXXXX}{Primary energy consumption, year XXXX (1990-2011).}
	\item{final_energyXXXX}{Final energy consumption, year XXXX (1990-2011).}
	\item{final_energyXXXX}{Early leavers from education and training - Perc. of the population aged 18-24 with at most lower secondary education and not in further education or training, year XXXX (1992-2012).}	
	\item{tertiaryXXXX}{Tertiary educational attainment - age group 30-34, year XXXX (2000-2012).}
	\item{risk_povertyXXXX}{People at risk of poverty or social exclusion - 1000 persons Perc. of total population, year XXXX (2004-2012).}
	\item{low_workXXXX}{People living in households with very low work intensity - 1000 persons Perc. of total population, year XXXX (2004-2012).}
	\item{risk_povertyXXXX}{People at risk of poverty after social transfers - 1000 persons Perc. of total population, year XXXX (2003-2012).}
	\item{deprivedXXXX}{Severely materially deprived people - 1000 persons Perc. of total population, year XXXX (2003-2012).}	
}}


\author{Vidoli F.}
\examples{data(EU_2020)}

\name{ci_mpi}
\alias{ci_mpi}
\title{Mazziotta-Pareto Index (MPI) method}
\description{Mazziotta-Pareto Index (MPI) is a non-linear composite index method which transforms a set of individual indicators in standardized variables and summarizes them using an arithmetic mean adjusted by a "penalty" coefficient related to the variability of each unit (method of the coefficient of variation penalty).}

\usage{ci_mpi(x, indic_col, penalty="POS")}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{penalty}{Penalty direction; Use "POS" (default) in case of 'increasing' or 'positive' composite index (e.g., well-being index)), "NEG" in case of 'decreasing' or 'negative' composite index (e.g., poverty index).}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_mpi_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="mpi".}
}

\references{
De Muro P., Mazziotta M., Pareto A. (2011), "\emph{Composite Indices of Development and Poverty: An Application to MDGs}", Social Indicators Research, Volume 104, Number 1, pp. 1-18.}

\author{Vidoli F., Scaccabarozzi A.}

\seealso{ \code{\link{ci_bod}}, \code{\link{normalise_ci}}}

\examples{
data(EU_NUTS1)

# Please, pay attention. MPI can be calculated only with this standardization method:
# method=1, z.mean=100 and z.std=10
# For more info, please see references.

data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),c("NEG","POS"),method=1,z.mean=100, z.std=10)
CI = ci_mpi(data_norm$ci_norm, penalty="NEG")

}

\name{ci_rbod_mdir}
\alias{ci_rbod_mdir}
\title{Robust multi-directional Benefit of the Doubt approach (MDRBoD)}
\description{Robust Multi-directional Benefit of the Doubt (MDRBoD) allows to introduce the non-compensability among simple indicators in a standard Robust BOD in an objective manner: the preference structure, i.e., the direction, is determined directly from the data and is specific for each unit and these estimated values are calculated as the reference sample varies in order to smooth out the effect of outliers or out-of-range data.}

\usage{ci_rbod_mdir(x,indic_col,M, B, interval)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
  \item{M}{The number of elements in each of the bootstrapped samples.}
  \item{B}{The number of bootstrap replicates.}
  \item{interval}{Desired probability for Student distribution [see function qt()]; default = 0.05.}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_rbod_mdir_est}{Composite indicator estimated values.}
  \item{conf}{lower_ci and upper_ci; Estimated confidence interval for the composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="rbod_mdir".}
  \item{ci_rbod_mdir_spec}{Simple indicators specific scores.}
  \item{ci_rbod_mdir_dir}{Directions for each simple indicator and unit.}
  
}

\references{

F. Vidoli, E. Fusco, G. Pignataro, C. Guccio (2024) "\emph{Multi-directional Robust Benefit of the Doubt model: An application to the measurement of the quality of acute care services in OECD countries}", Socio-Economic Planning Sciences. https://doi.org/10.1016/j.seps.2024.101877  

}

\author{Vidoli F.}

\seealso{ \code{\link{ci_rbod}}, \code{\link{ci_bod_mdir}}}

\examples{
data(BLI_2017)
CI <- ci_rbod_mdir(BLI_2017,c(2:12), M=6,B=20, interval=0.05)
}

\name{ci_bod_constr}
\alias{ci_bod_constr}
\title{Constrained Benefit of the Doubt approach (BoD)}

\description{The constrained Benefit of the Doubt function lets to introduce additional constraints to the weight variation in the optimization procedure so that all the weights obtained are greater than a lower value (low_w) and less than an upper value (up_w).}

\usage{ci_bod_constr(x,indic_col,up_w,low_w)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
  \item{up_w}{Importance weights upper bound.}
  \item{low_w}{Importance weights lower bound.}
}

%\details{...}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_bod_constr_est}{Constrained composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="bod_constrained".}
  \item{ci_bod_constr_weights}{Raw constrained weights assigned to the simple indicators.}
}

\references{ Van Puyenbroeck T. and Rogge N. (2017) "\emph{Geometric mean quantity index numbers with Benefit-of-the-Doubt weights}", European Journal of Operational Research, Volume 256, Issue 3, Pages 1004 - 1014.}

\author{Rogge N., Vidoli F.}

\seealso{ \code{\link{ci_bod_dir}},\code{\link{ci_bod}} }

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_bod_constr(Indic,up_w=1,low_w=0.05)

data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),polarity = c("POS","POS"), method=2)
CI = ci_bod_constr(data_norm$ci_norm,c(1:2),up_w=1,low_w=0.05)
}

\name{ci_ogwa}
\alias{ci_ogwa}

\title{Ordered Geographically Weighted Average (OWA)}
\description{The Ordered Geographically Weighted Averaging (OWA) operator is an extension of the multi-criteria decision aggregation method called OWA (Yager, 1988) that accounts for spatial heterogeneity.}

\usage{ci_ogwa(x, id, indic_col, atleastjp, coords,
                    kernel = "bisquare", adaptive = F, bw, 
                    p = 2, theta = 0, longlat = F, dMat)}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{id}{Units' unique identifier.}
  \item{indic_col}{Simple indicators column number.}
  \item{coords}{A two-column matrix of latitude and longitude coordinates.}
  \item{atleastjp}{Fuzzy linguistic quantifier "At least j".}
  \item{kernel}{function chosen as follows:
                gaussian: wgt = exp(-.5*(vdist/bw)^2);
                exponential: wgt = exp(-vdist/bw);
                bisquare: wgt = (1-(vdist/bw)^2)^2 if vdist < bw, wgt=0 otherwise;
                tricube: wgt = (1-(vdist/bw)^3)^3 if vdist < bw, wgt=0 otherwise;
                boxcar: wgt=1 if dist < bw, wgt=0 otherwise.}
  \item{adaptive}{if TRUE calculate an adaptive kernel where the bandwidth (bw) corresponds to                      the number of nearest neighbours (i.e. adaptive distance); default is FALSE,                      where a fixed kernel is found (bandwidth is a fixed distance).}
  \item{bw}{bandwidth used in the weighting function.}
  \item{p}{the power of the Minkowski distance, default is 2, i.e. the Euclidean distance.}	
  \item{theta}{an angle in radians to rotate the coordinate system, default is 0.}	
  \item{longlat}{if TRUE, great circle distances will be calculated.}	
  \item{dMat}{a pre-specified distance matrix, it can be calculated by the function \code{\link[GWmodel]{gw.dist}}.}	

}

\value{An object of class "CI". This is a list containing the following elements:
  \item{CI_OGWA_n}{Composite indicator estimated values for OGWA-.}
  \item{CI_OGWA_p}{Composite indicator estimated values for OGWA+.}
  \item{wp}{OGWA weights' vector "More than j".}
  \item{wn}{OGWA weights' vector "At least j".}
  \item{ci_method}{Method used; for this function ci_method="ogwa".}
}

\references{
Fusco, E., Liborio, M.P., Rabiei-Dastjerdi, H., Vidoli, F., Brunsdon, C. and Ekel, P.I. (2023), Harnessing Spatial Heterogeneity in Composite Indicators through the Ordered Geographically Weighted Averaging (OGWA) Operator. Geographical Analysis. https://doi.org/10.1111/gean.12384
}

\author{Fusco E., Liborio M.P.}

\seealso{ \code{\link{ci_owa}}}

\examples{
data(data_HPI)

data_HPI_2019 = data_HPI[data_HPI$year==2019,]
Indic_name = c("Life_Expectancy","Ladder_of_life","Ecological_Footprint")

Indic_norm = normalise_ci(data_HPI_2019, Indic_name, c("POS","POS","NEG"),method=2)$ci_norm
Indic_norm = Indic_norm[Indic_norm$Life_Expectancy>0 & 
              Indic_norm$Ladder_of_life>0 & 
              Indic_norm$Ecological_Footprint >0,]

Indic_CI = data.frame(Indic_norm, 
                       data_HPI_2019[rownames(Indic_norm),
                       c("lat","long","HPI","ISO","Country")])

atleast = 2

coord = Indic_CI[,c("lat","long")]

CI_ogwa_n = ci_ogwa(Indic_CI, id="ISO", 
                      indic_col=c(1:3), 
                      atleastjp=atleast,
                      coords=as.matrix(coord),
                      kernel = "gaussian",
                      adaptive=FALSE, 
                      longlat=FALSE)$CI_OGWA_n


#CI_ogwa_p = ci_ogwa(Indic_CI, id="ISO", 
#                      indic_col=c(1:3), 
#                     atleastjp=atleast,
#                      coords=as.matrix(coord),
#                      kernel = "gaussian",
#                      adaptive=FALSE, 
#                      longlat=FALSE)$CI_OGWA_p

}

\name{ci_owa}
\alias{ci_owa}

\title{Ordered Weighted Average (OWA)}
\description{The Ordered Weighted Averaging (OWA) operator is a multi-criteria decision aggregation method that is structurally non-compensatory (Yager, 1988).}

\usage{ci_owa(x, id, indic_col, atleastjp)}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{id}{Units' unique identifier.}
  \item{indic_col}{Simple indicators column number.}
  \item{atleastjp}{Fuzzy linguistic quantifier "At least j".}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{CI_OWA_n}{Composite indicator estimated values for OWA-.}
  \item{CI_OWA_p}{Composite indicator estimated values for OWA+.}
  \item{wp}{OWA weights' vector "More than j".}
  \item{wn}{OWA weights' vector "At least j".}
  \item{ci_method}{Method used; for this function ci_method="owa".}
}

\references{

Yager, R. R. (1988). On ordered weighted averaging aggregation operators in multicriteria decision making. IEEE Transactions on systems, Man, and Cybernetics, 18(1), 183-190.

}

\author{Fusco E., Liborio M.P.}

\seealso{ \code{\link{ci_ogwa}}}

\examples{
data(data_HPI)

data_HPI = data_HPI[complete.cases(data_HPI),]
data_HPI_2019 = data_HPI[data_HPI$year==2019,]

Indic_name = c("Life_Expectancy","Ladder_of_life","Ecological_Footprint")
Indic_norm = data.frame("ISO"=data_HPI_2019$ISO, 
                        normalise_ci(data_HPI_2019[, Indic_name], 
                        c(1:3), 
                        c("POS","POS","NEG"),
                        method=2)$ci_norm)
                        
Indic_norm = Indic_norm[Indic_norm$Life_Expectancy>0 & 
                         Indic_norm$Ladder_of_life>0 & 
                         Indic_norm$Ecological_Footprint >0 ,]

atleast = 2
CI_owa_n = ci_owa(Indic_norm, id="ISO", 
                   indic_col=c(2:4), 
                   atleastjp=atleast)$CI_OWA_n
CI_owa_p = ci_owa(Indic_norm, id="ISO", 
                   indic_col=c(2:4), 
                   atleastjp=atleast)$CI_OWA_p
}

\name{normalise_ci}
\alias{normalise_ci}

\title{
Normalisation and polarity functions
}

\description{This function lets to normalise simple indicators according to the polarity of each one.}

\usage{
normalise_ci(x, indic_col, polarity, method=1, z.mean=0, z.std=1, ties.method ="average")
}

\arguments{
  \item{x}{A data frame containing simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{method}{Normalisation methods: 
						\itemize{
								\item \bold{1} (default) = standardization or z-scores using the following formulation: \deqn{z_{ij}=z.mean \pm \frac{x_{ij}-M_{x_j}}{S_{x_j}}\cdot z.std} where \eqn{\pm} depends on \emph{polarity} parameter and \emph{z.mean} and \emph{z.std} represent the shifting parameters.
                
								\item \bold{2} = Min-max method using the following formulation: 
								
								if \emph{polarity}="POS": \deqn{\frac{x-min(x)}{max(x)-min(x)}} 
                if \emph{polarity}="NEG": \deqn{\frac{max(x)-x}{max(x)-min(x)}}
								
								\item \bold{3} = Ranking method. If \emph{polarity}="POS" ranking is increasing, while if \emph{polarity}="NEG" ranking is decreasing.
						}
				}
  \item{polarity}{Polarity vector: "POS" = positive, "NEG" = negative. The polarity of a individual indicator is the sign of the relationship between the indicator and the phenomenon to be measured (e.g., in a well-being index, "GDP per capita" has 'positive' polarity and "Unemployment rate" has 'negative' polarity).}
  \item{z.mean}{If method=1, Average shifting parameter. Default is 0.}
  \item{z.std}{If method=1, Standard deviation expansion parameter. Default is 1.}
  \item{ties.method}{If method=3, A character string specifying how ties are treated, see \code{\link{rank}} for details. Default is "average".}
}

%DA FINIRE _________________________________
%\details{ 
%
%   Min-max method in case of NEG polarity
%   
%   Ranking method in case of NEG polarity  
%______________________________________________________________
%}

\value{
  \item{ci_norm}{A data.frame containing normalised score of the choosen simple indicators.}
  \item{norm_method}{Normalisation method used.}
}

\references{OECD, "\emph{Handbook on constructing composite indicators: methodology and user guide}", 2008, pag.30.}

\author{ Vidoli F.}

\seealso{ \code{\link{ci_bod}}, \code{\link{ci_mpi}}}

\examples{
data(EU_NUTS1)

# Standard z-scores normalisation #
data_norm = normalise_ci(EU_NUTS1,c(2:3),c("NEG","POS"),method=1,z.mean=0, z.std=1)
summary(data_norm$ci_norm)

# Normalisation for MPI index #
data_norm = normalise_ci(EU_NUTS1,c(2:3),c("NEG","POS"),method=1,z.mean=100, z.std=10)
summary(data_norm$ci_norm)

data_norm = normalise_ci(EU_NUTS1,c(2:3),c("NEG","POS"),method=2)
summary(data_norm$ci_norm)
}

\name{ci_wroclaw}
\alias{ci_wroclaw}
\title{Wroclaw Taxonomic Method}

\description{Wroclaw taxonomy method (also known as the dendric method), originally developed at the University of Wroclaw, is based on the distance from a theoretical unit characterized by the best performance for all indicators considered; the composite indicator is therefore based on the sum of euclidean distances from the ideal unit and normalized by a measure of variability of these distance (mean + 2*std).}

\usage{ci_wroclaw(x,indic_col)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{Simple indicators column number.}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_wroclaw_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="wroclaw".}
}

\details{Please pay attention that \emph{ci_wroclaw_est} is the distance from the "ideal" unit; so, units with higher values for the simple indicators get lower values of composite indicator.}

\references{

UNESCO, "\emph{Social indicators: problems of definition and of selection}", Paris 1974.

Mazziotta C., Mazziotta M., Pareto A., Vidoli F., "\emph{La sintesi di indicatori territoriali di dotazione
infrastrutturale: metodi di costruzione e procedure di ponderazione a confronto}", Rivista di
Economia e Statistica del territorio, n.1, 2010.
}

\author{ Vidoli F.}

\seealso{ \code{\link{ci_bod}}, \code{\link{ci_mpi}}}

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_wroclaw(Indic)

data(EU_NUTS1)
CI = ci_wroclaw(EU_NUTS1,c(2:3))

data(EU_2020)
data_selez = EU_2020[,c(1,22,191)]
data_norm = normalise_ci(data_selez,c(2:3),c("POS","NEG"),method=3)
ci_wroclaw(data_norm$ci_norm,c(1:2))

}

\name{data_HPI}
\alias{data_HPI}
\title{Happy Planet Index 2017-2019 indicators}
\description{Data related to Happy Planet Index for 151 countries and the period 2017-2019.

For more info, please see \url{https://happyplanetindex.org}.
}
\usage{data(data_HPI)}

\format{data_HPI is a dataset with 453 observations and 10 variables.

\describe{
	\item{Country}{Country name}	
    \item{ISO}{ISO code}	
    \item{year}{Years 2017-2019}	
    \item{Continent}{Continent}	
    \item{Population}{Population (thousands)}	
    \item{Life_Expectancy}{Life Expectancy (years)}	
    \item{Ladder_of_life}{Ladder of life (Wellbeing) (0-10)}	
    \item{Ecological_Footprint}{Ecological Footprint (g ha)}	
    \item{HPI}{HPI}	
    \item{GDP_per_capita}{GDP per capita ($)}	
}}

\references{\url{https://happyplanetindex.org}}
\author{Fusco E.}
\examples{data(data_HPI)}

\name{ci_ampi}
\alias{ci_ampi}
\title{Adjusted Mazziotta-Pareto Index (AMPI) method}
\description{Adjusted Mazziotta-Pareto Index (AMPI) is a non-compensatory composite index that allows to take into account the time dimension, too. The calculation part is similat to the MPI framework, but the standardization part make the scores obtained over the years comparable.}

\usage{ci_ampi(x, indic_col, gp, time, polarity, penalty = "NEG")}

\arguments{
  \item{x}{A data.frame containing simple indicators in a Long Data Format.}
  \item{indic_col}{Simple indicators column number.}
  \item{gp}{Goalposts; to facilitate the interpretation of results, the \code{goalposts} can be chosen so that 100 represents a reference value (e.g., the average in a given year).}
  \item{time}{The time variable (mandatory); if the analysis is carried out over a single year, it is necessary to create a constant variable (i.e. \code{dataframe@year <- 2014}).}
  \item{polarity}{Polarity vector: "POS" = positive, "NEG" = negative. The polarity of a individual indicator is the sign of the relationship between the indicator and the phenomenon to be measured (e.g., in a well-being index, "GDP per capita" has 'positive' polarity and "Unemployment rate" has 'negative' polarity).}
  \item{penalty}{Penalty direction; Use "NEG" (default) in case of 'increasing' or 'positive' composite index (e.g., well-being index)), "POS" in case of 'decreasing' or 'negative' composite index (e.g., poverty index).}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_ampi_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="ampi".}
  \item{ci_penalty}{Matrix containing penalties only.}
  \item{ci_norm}{List containing only the normalised indicators for each year.}
}

\details{Author thanks Leonardo Alaimo for their help and for making available the original code of the AMPI function. Federico Roscioli for his integrations to the original code.}

\references{
Mazziotta, M., Pareto, A. (2013) "\emph{A Non-compensatory Composite Index for Measuring Well-being over Time}", Cogito. Multidisciplinary Research Journal Vol. V, no. 4, pp. 93-104

Mazziotta, M., Pareto, A. (2016)."\emph{On a Generalized Non-compensatory Composite Index for Measuring Socio-economic Phenomena}", Cogito. Social Indicators Research, Vol. 127, no. 3, pp. 983-1003
}

\author{Fusco E., Alaimo L., Giovagnoli C., Patelli L., F. Roscioli}

\seealso{ \code{\link{ci_bod}}, \code{\link{normalise_ci}}}

\examples{
data(EU_2020)

data_test = EU_2020[,c("employ_2010","employ_2011","finalenergy_2010","finalenergy_2011")] 

EU_2020_long<-reshape(data_test, 
                      varying=c("employ_2010","employ_2011","finalenergy_2010","finalenergy_2011"), 
                      direction="long", 
                      idvar="geo", 
                      sep="_")

CI <- ci_ampi(EU_2020_long, 
              indic_col=c(2:3),
              gp=c(50, 100), 
              time=EU_2020_long[,1], 
              polarity= c("POS", "POS"), 
              penalty="POS")
CI$ci_ampi_est
CI$ci_penalty
CI$ci_norm
}

\name{BLI_2017}
\alias{BLI_2017}
\title{Better Life Index 2017 indicators}
\description{Data related to BLI Edition 2017 (OECD, 2017) for all 38 OECD and non-OECD countries (Data extracted on: 19\02\2020).

For more info, please see \url{https://data-explorer.oecd.org}.
}

\usage{data(BLI_2017)}

\format{BLI_2017 is a dataset with 38 observations and 12 indicators.

\describe{
	\item{country}{OECD and non-OECD countries.}	
    \item{housing}{Housing.}	
    \item{income}{Income and wealth.}	
    \item{jobs}{Jobs and earnings.}	
    \item{community}{Community engagement.}	
    \item{education}{Education.}	
    \item{environment}{Environment quality.}	
    \item{civic}{Civic engagement.}	
    \item{health}{Health.}	
    \item{satisfaction}{Life satisfaction.}	
    \item{safety}{Personal security (safety).}	
    \item{worklife}{Work-Life balance.}	
}}

\author{Fusco E.}
\examples{data(BLI_2017)}

\name{ci_rbod_dir}
\alias{ci_rbod_dir}

\title{Directional Robust Benefit of the Doubt approach (D-RBoD)}

\description{Directional Robust Benefit of the Doubt approach (D-RBoD) is the directional robust version of the BoD method.}

\usage{ci_rbod_dir(x,indic_col,M,B,dir)}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{M}{The number of elements in each of the bootstrapped samples.}
  \item{B}{The number of bootstap replicates.}
  \item{dir}{Main direction. For example you can set the average rates of substitution.}  
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_rbod_dir_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="rbod_dir".}
}

\references{

Daraio C., Simar L., "\emph{Introducing environmental variables in nonparametric frontier models: a probabilistic approach}", Journal of productivity analysis, 2005, 24(1), 93 121.

Simar L., Vanhems A., "\emph{Probabilistic characterization of directional distances and their robust versions}", Journal of Econometrics, 2012, 166(2), 342 354.

Vidoli F., Fusco E., Mazziotta C., "\emph{Non-compensability in composite indicators: a robust directional frontier method}", Social Indicators Research, Springer Netherlands.

}

\author{Fusco E., Vidoli F.}

\seealso{ \code{\link{ci_bod}}, \code{\link{ci_rbod}}}

\examples{
data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),polarity = c("POS","POS"), method=2)
CI = ci_rbod_dir(data_norm$ci_norm, c(1:2), M = 25, B = 50, c(1,0.1)) 
}

\name{EU_NUTS1}
\alias{EU_NUTS1}
\title{EU NUTS1 Transportation data}
\description{Eurostat regional transport statistics (reg_tran) data, year 2012.}
\usage{data(EU_NUTS1)}
\format{EU_NUTS1 is a dataset with 34 observations and two indicators describing transportation infrastructure endowment of the main (in terms of population and GDP) European NUTS1 regions: France, Germany, Italy, Spain (United Kingdom has been omitted, due to lack of data concerning railways).

\describe{
    \item{roads}{Calculated as (2 * Motorways - Kilometres per 1000 km2 + Other roads - Kilometres per 1000 km2 )/3}	
    \item{trains}{Calculated as (2 *Railway lines double+Electrified railway lines)/3}	
}}

\references{
 Vidoli F., Mazziotta C., "\emph{Robust weighted composite indicators by means of frontier methods with an application to European infrastructure endowment}", Statistica Applicata, Italian Journal of Applied Statistics, 2013.}
\author{Vidoli F.}
\examples{data(EU_NUTS1)}

\name{ci_geom_gen}
\alias{ci_geom_gen}
\title{Generalized geometric mean quantity index numbers}

\description{This function use the geometric mean to aggregate the single indicators. Two weighting criteria has been implemented: EQUAL: equal weighting and BOD: Benefit-of-the-Doubt weights following the Puyenbroeck and Rogge (2017) approach.}

\usage{ci_geom_gen(x,indic_col,meth,up_w,low_w,bench)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
  \item{meth}{"EQUAL" = Equal weighting set, "BOD" =  Benefit-of-the-Doubt weighting set.}
  \item{up_w}{if meth="BOD"; upper bound of the weighting set.}
  \item{low_w}{if meth="BOD"; lower bound of the weighting set.}
  \item{bench}{Row number of the benchmark unit used to normalize the data.frame x.}
}


\value{An object of class "CI". This is a list containing the following elements:

If meth = "EQUAL":
  \item{ci_mean_geom_est}{: Composite indicator estimated values.}
  \item{ci_method}{: Method used; for this function ci_method="mean_geom".}

If meth = "BOD":  
  \item{ci_geom_bod_est}{: Constrained composite indicator estimated values.}
  \item{ci_geom_bod_weights}{: Raw constrained weights assigned to the simple indicators.}
  \item{ci_method}{: Method used; for this function ci_method="geometric_bod".}

}

\references{ Van Puyenbroeck T. and Rogge N. (2017) "\emph{Geometric mean quantity index numbers with Benefit-of-the-Doubt weights}", European Journal of Operational Research, Volume 256, Issue 3, Pages 1004 - 1014}

\author{Rogge N., Vidoli F.}

\seealso{ \code{\link{ci_bod_dir}},\code{\link{ci_bod}} }

\examples{
i1 <- seq(0.3, 1, len = 100) - rnorm (100, 0.1, 0.03)
i2 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.1, 0.03)
i3 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.1, 0.03)
Indic = data.frame(i1, i2,i3)

geom1 = ci_geom_gen(Indic,c(1:3),meth = "EQUAL")
geom1$ci_mean_geom_est
geom1$ci_method


geom2 = ci_geom_gen(Indic,c(1:3),meth = "BOD",0.7,0.3,100)
geom2$ci_geom_bod_est
geom2$ci_geom_bod_weights


}

\name{ci_rbod}
\alias{ci_rbod}

\title{Robust Benefit of the Doubt approach (RBoD)}
\description{Robust Benefit of the Doubt approach (RBoD) is the robust version of the BoD method. It is based on the concept of the expected minimum input function of order-\emph{m} so "\emph{in place of looking for the lower boundary of the support of F, as was typically the case for the full-frontier (DEA or FDH), the order-m efficiency score can be viewed as the expectation of the maximal score, when compared to m units randomly drawn from the population of units presenting a  greater level of simple indicators}", Daraio and Simar (2005).}

\usage{ci_rbod(x,indic_col,M,B)}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{M}{The number of elements in each of the bootstrapped samples.}
  \item{B}{The number of bootstrap replicates.}
  
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_rbod_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="rbod".}
}

\references{

Daraio, C., Simar, L. "\emph{Introducing environmental variables in nonparametric frontier models: a probabilistic approach}", Journal of productivity analysis, 2005, 24(1), 93 - 121.

Vidoli F., Mazziotta C., "\emph{Robust weighted composite indicators by means of frontier methods with an application to European infrastructure endowment}", Statistica Applicata, Italian Journal of Applied Statistics, 2013.

}

\author{Vidoli F.}

\seealso{ \code{\link{ci_bod}}}

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_rbod(Indic,B=10)

data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),polarity = c("POS","POS"), method=2)
CI = ci_rbod(data_norm$ci_norm,c(1:2),M=10,B=20)
}

\name{ci_rbod_constr_bad}
\alias{ci_rbod_constr_bad}
\title{Robust constrained Benefit of the Doubt approach (BoD) in presence of undesirable  indicators}
\description{The Robust constrained Benefit of the Doubt function introduces additional constraints to the weight variation in the optimization procedure (Constrained Virtual Weights Restriction) allowing to restrict the importance attached to a single indicator expressed in percentage terms, ranging between a lower and an upper bound (VWR); this function, furthermore, allows to calculate the composite indicator simultaneously in presence of undesirable (bad) and desirable (good) indicators allowing to impose a preference structure (ordVWR). This function is the robust version of the \code{ci_bod_constr_bad}: it is based on the concept of the expected minimum input function of order-\emph{m} (Daraio and Simar, 2005) allowing to compare the unit under analysis against \code{M} peers by extracting \code{B} samples with replacement.}

\usage{ci_rbod_constr_bad(x, indic_col, ngood=1, nbad=1, low_w=0, pref=NULL, M, B) }

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
  \item{ngood}{The number of desirable outputs; it has to be greater than 0.}
  \item{nbad}{The number of undesirable  outputs; it has to be greater than 0.}
  \item{low_w}{Importance weights lower bound.}
  \item{pref}{The preference vector among indicators; For example if \code{Indic1} is the most important, \code{Indic2},\code{Indic3} are more important than \code{Indic4} and no preference judgment on \code{Indic5} (= not included in the vector), the \code{pref} vector can be written as: \code{c("Indic1", "Indic2","Indic3","Indic4")}}
  \item{M}{The number of elements in each of the bootstrapped samples.}
  \item{B}{The number of bootstrap replicates.}
  
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_rbod_constr_bad_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="rbod_constr_bad".}
  \item{ci_rbod_constr_bad_weights}{Raw weights assigned to each simple indicator.}
  \item{ci_rbod_constr_bad_target}{Indicator target values.}
}

\references{
Rogge N., de Jaeger S. and Lavigne C. (2017) "\emph{Waste Performance of NUTS 2-regions in the EU: A Conditional Directional Distance Benefit-of-the-Doubt Model}", Ecological Economics, vol.139, pp. 19-32.

Zanella A., Camanho A.S. and Dias T.G. (2015) "\emph{Undesirable outputs and weighting schemes in composite indicators based on data envelopment analysis}", European Journal of Operational Research, vol. 245(2), pp. 517-530.
}

\author{Fusco E., Rogge N.}

\seealso{ \code{\link{ci_bod_constr}}, \code{\link{ci_bod_constr_bad}} }



\examples{
#data(EU_2020)
#indic <- c("employ_2011", "percGDP_2011", "gasemiss_2011","deprived_2011")  
#dat <- EU_2020[-c(10,18),indic]

# Robust BoD Constrained VWR
#CI_BoD_C = ci_rbod_constr_bad(dat, ngood=2, nbad=2, low_w=0.05, pref=NULL, M=10, B=50)
#CI_BoD_C$ci_rbod_constr_bad_est

# Robust BoD Constrained ordVWR
#importance <- c("gasemiss_2011","percGDP_2011","employ_2011")
#CI_BoD_C = ci_rbod_constr_bad(dat, ngood=2, nbad=2, low_w=0.05, pref=importance, M=10, B=50)
#CI_BoD_C$ci_rbod_constr_bad_est
}

\name{ci_mean_min}
\alias{ci_mean_min}
\title{Mean-Min Function}
\description{The Mean-Min Function (MMF) is an intermediate case between arithmetic \code{mean}, according to which no unbalance is penalized, and \code{min} function, according to which the penalization is maximum. It depends on two parameters that are respectively related to the intensity of penalization of unbalance (\eqn{\alpha}) and intensity of complementarity (\eqn{\beta}) among indicators.}

\usage{ci_mean_min(x, indic_col, alpha, beta)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{alpha}{The intensity of penalisation of unbalance among indicators, \eqn{0 \le \alpha \le 1}}
  \item{beta}{The intensity of complementarity among indicators, \eqn{\beta \ge 0}}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_mean_min_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="mean_min".}
}

\references{Casadio Tarabusi, E., & Guarini, G. (2013) "\emph{An unbalance adjustment method
for development indicators}", Social indicators research, 112(1), 19-45.}

\author{Vidoli F.}

\seealso{ \code{\link{ci_mpi}}, \code{\link{normalise_ci}}}

\examples{
data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),c("NEG","POS"),method=2)
CI = ci_mean_min(data_norm$ci_norm, alpha=0.5, beta=1)

}

\name{ci_generalized_mean}
\alias{ci_generalized_mean}
\title{Weighting method based on generalized mean}

\description{Generalized means are a family of functions for aggregating sets of numbers (it include as special cases the Pythagorean means, arithmetic, geometric, and harmonic means). The generalized mean is also known as power mean or Holder mean.}

\usage{ci_generalized_mean(x, indic_col, p, na.rm=TRUE)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{p}{Exponent \eqn{p} (real number).}
  \item{na.rm}{Remove NA values before processing; default is TRUE.}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_generalized_mean_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="generalized_mean".}
}

%\references{??}

\note{
The \emph{generalized mean} with the exponent \eqn{p} can be espressed as:
\deqn{M_p(I_1,\dots,I_n) = \left( \frac{1}{n} \sum_{i=1}^n I_i^p \right)^{\frac{1}{p}}}
Particular case are:
\eqn{p=-\infty}: minimum, \eqn{p=-1}: harmonic mean, \eqn{p=0}: geometric mean, 
\eqn{p=1}: arithmetic mean, \eqn{p=2}: root-mean-square and \eqn{p=\infty}: maximum.
}

\author{
  Vidoli F.
}

\seealso{ \code{\link{ci_geom_gen}}, \code{\link{ci_factor}}}

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_generalized_mean(Indic, p=-1) # harmonic mean

data(EU_NUTS1)
CI = ci_generalized_mean(EU_NUTS1,c(2:3),p=2) # geometric mean
}

\name{ci_bod_mdir}
\alias{ci_bod_mdir}
\title{Multi-directional Benefit of the Doubt approach (MDBoD)}
\description{Multi-directional Benefit of the Doubt (MDBoD) allows to introduce the non-compensability among simple indicators in a standard BOD in an objective manner: the preference structure, i.e., the direction, is determined directly from the data and is specific for each unit.}

\usage{ci_bod_mdir(x,indic_col)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_bod_mdir_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="bod".}
  \item{ci_bod_mdir_spec}{Simple indicators specific scores.}
  \item{ci_bod_mdir_dir}{Directions for each simple indicator and unit.}
  
}

\references{

Fusco E. (2023) "\emph{Potential improvements approach in composite indicators construction: the Multi-directional Benefit of the Doubt model}", Socio-Economic Planning Sciences, vol. 85, 101447
}

\author{Fusco E.}

\seealso{ \code{\link{ci_bod_dir}}, \code{\link{ci_rbod_mdir}}}

\examples{
data(BLI_2017)
CI <- ci_bod_mdir(BLI_2017,c(2:12))
}

\name{ci_rbod_spatial}
\alias{ci_rbod_spatial}

\title{Spatial robust Benefit of the Doubt approach (Sp-RBoD)}
\description{The Spatial robust Benefit of the Doubt approach (Sp-RBoD) method allows to take into account the spatial contextual condition into the robust Benefit of the Doubt method.}

\usage{ci_rbod_spatial(x, indic_col, M=20, B=100, W) }

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{M}{The number of elements in each of the bootstrapped samples; default is 20.}
  \item{B}{The number of bootstrap replicates; default is 100.}
  \item{W}{The spatial weights matrix. A square non-negative matrix with no NAs representing spatial weights; may be a matrix of class "sparseMatrix" (spdep package)}
  
}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_rbod_spatial_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="rbod_spatial".}
}

\references{
Fusco E., Vidoli F., Sahoo B.K. (2018) "\emph{Spatial heterogeneity in composite indicator: a methodological proposal}", Omega, Vol. 77, pp. 1-14
}

\author{Fusco E., Vidoli F.}

\seealso{ \code{\link{ci_rbod}}}

\examples{

data(EU_NUTS1)

coord = EU_NUTS1[,c("Long","Lat")]
k<-knearneigh(as.matrix(coord), k=5)
k_nb<-knn2nb(k)
W_mat <-nb2mat(k_nb,style="W",zero.policy=TRUE)

CI = ci_rbod_spatial(EU_NUTS1,c(2:3),M=10,B=20, W=W_mat)
}

\name{ci_geom_bod_intertemp}
\alias{ci_geom_bod_intertemp}
\title{Intertemporal analysis for geometric mean quantity index numbers}

\description{Intertemporal analysis for geometric mean quantity index numbers with Benefit-of-the-Doubt weights - see function \code{\link{ci_bod_constr}}.}

\usage{ci_geom_bod_intertemp(x0,x1,indic_col,up_w,low_w,bench)}

\arguments{
  \item{x0}{A data.frame containing simple indicators - time 0}
  \item{x1}{A data.frame containing simple indicators - time 1}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
  \item{up_w}{Weights upper bound.}
  \item{low_w}{Weights lower bound.}
  \item{bench}{Row number of the benchmark unit}
}

%\details{...}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_geom_bod_intertemp_est}{A matrix containing the Overall Change (period t1 vs t0), the Change Effect (period t1 vs t0), the Benchmark Effect (period t1 vs t0) and Weight Effect (period t1 vs t0).}
  \item{ci_method}{Method used; for this function ci_method="Intertemporal_effects_Geometric_BoD".}
}

\references{ Van Puyenbroeck T. and Rogge N. (2017) "\emph{Geometric mean quantity index numbers with Benefit-of-the-Doubt weights}", European Journal of Operational Research, Volume 256, Issue 3, Pages 1004 - 1014}

\author{Rogge N., Vidoli F.}

\seealso{ \code{\link{ci_bod_constr}},\code{\link{ci_bod}} }

\examples{

i1_t1 <- seq(0.3, 0.5, len = 100)
i2_t1 <- seq(0.3, 1, len = 100)  
Indic_t1 = data.frame(i1_t1, i2_t1)

i1_t0 <- i1_t1 - rnorm (100, 0.2, 0.03)
i2_t0 <- i2_t1   - rnorm (100, 0.2, 0.03)
Indic_t0 = data.frame(i1_t0, i2_t0)

intertemp = ci_geom_bod_intertemp(Indic_t0,Indic_t1,c(1:2),up_w=0.95,low_w=0.05,1)
intertemp 

}

\name{plot_M_robust_ci}
\alias{plot_M_robust_ci}
\title{Visualize the percentage of outperforming units in robust methods}
\description{This function generates a plot showing the proportion of outperforming units (i.e., units with a score greater than 1) across varying subset sizes (M) used in robust Benefit of the Doubt (BoD) models. It helps to analyze how the choice of subset size impacts the number of outperforming units identified by the model.}

\usage{plot_M_robust_ci(x,indic_col,method,mvector,B,dir, interval)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
  \item{method}{The method to be tested. Implemented methods are "rbod", "rbod", "rbod_mdir".}
  \item{mvector}{The vector of different elements in each of the bootstrapped samples to be tested.}
  \item{B}{The number of bootstrap replicates.}
  \item{dir}{Main direction. For example you can set the average rates of substitution.}
  \item{interval}{Desired probability for Student distribution [see function qt()]; default = 0.05.}
}

\author{Fusco E.}

\seealso{ \code{\link{ci_rbod}}, \code{\link{ci_rbod_dir}}, \code{\link{ci_rbod_mdir}}}

\examples{
data(EU_NUTS1)
data_norm = normalise_ci(EU_NUTS1,c(2:3),polarity = c("POS","POS"), method=2)
plot_M_robust_ci(data_norm$ci_norm, c(1:2), method = "rbod", 
                 mvector = seq(5,25,5), B = 10)
plot_M_robust_ci(data_norm$ci_norm, c(1:2), method = "rbod_dir", 
                 mvector = seq(5,25,5), B = 10, dir=c(1,0.1))


data(BLI_2017)
plot_M_robust_ci(x = BLI_2017, indic_col = c(2:12), method = "rbod_mdir", 
                 mvector = seq(5,10,1), B = 10, interval = 0.05)
}

\name{ci_smaa_constr}
\alias{ci_smaa_constr}
\title{Constrained stochastic multi-objective acceptability analysis (C-SMAA)}
\description{Stochastic multiobjective acceptability analysis (SMAA) is a multicriteria decision support technique for multiple decision makers based on exploring the weight space. Inaccurate or uncertain input data can be represented as probability distributions. In SMAA the decision makers need not express their preferences explicitly or implicitly; instead the technique analyses what kind of valuations would make each alternative the preferred one. The method produces for each alternative an acceptability index measuring the variety of different valuations that support that alternative, a central weight vector representing the typical valuations resulting in that decision, and a confidence factor measuring whether the input data is accurate enough for making an informed decision. (R Lahdelma, J. Hokkanen and P. Salminen, 1998); this function, in particular, allows to restricts the range of allowable weights within the SMAA analysis.}

\usage{ci_smaa_constr(x,indic_col,rep, label, low_w=NULL)}

\arguments{
  \item{x}{A data.frame containing simple indicators.}
  \item{indic_col}{A numeric list indicating the positions of the simple indicators.}
  \item{rep}{Number of samples.}
  \item{label}{A factor column useful to identify units.}
  \item{low_w}{Importance weights lower bound vector; default is NULL (for standard SMAA)}
}

\details{Author thanks Giuliano Resce and Raffaele Lagravinese for their help and for making available the original code of the SMAA function.\\
The lower bound vector must be set as a vector of the same size as the number of simple indicators; for example - in the presence of two indicators - if you want to constrain only one indicator, you must write: \code{low_w = c (0,0.2)}.
}


\value{An object of class "CI". This is a list containing the following elements:
      \item{ci_smaa_constr_rank_freq}{Frequence of the SMAA ranks based on the sampled alternatives' values. The rows represent the analysis units while the first column represents the number of times the unit was in first rank, the second one in second rank and so on.}
          \item{ci_smaa_constr_average_rank}{The average rank.}
  \item{ci_smaa_constr_values}{The alternative values based on a set of samples from the criteria values distribution and the samples set from the feasible weight space.}
  \item{ci_method}{Method used; for this function ci_method="smaa_const".}

}

\references{

R. Lahdelma, P. Salminen (2001) "\emph{SMAA-2: Stochastic multicriteria acceptability analysis for group decision making}", Operations Research, 49(3), pp. 444-454

S. Greco, A. Ishizaka, B. Matarazzo and G. Torrisi (2017) "\emph{Stochastic multi-attribute acceptability analysis (SMAA): an application to the ranking of Italian regions}", Regional Studies

R. Lagravinese, P. Liberati and G. Resce (2017) "\emph{Exploring health outcomes by stochastic multi-objective acceptability analysis: an application to Italian regions}", Working Papers. Collection B: Regional and sectoral economics, 1703, Universidade de Vigo, GEN - Governance and Economics research Network.

}

\author{Vidoli F.}

\seealso{ \code{\link{ci_bod}}}

\examples{


# ----- Define a function for plotting a matrix ----- #
myImagePlot <- function(x, ...){
     min <- min(x)
     max <- max(x)
     yLabels <- rownames(x)
     xLabels <- colnames(x)
     title <-c()
  # check for additional function arguments
  if( length(list(...)) ){
    Lst <- list(...)
    if( !is.null(Lst$zlim) ){
       min <- Lst$zlim[1]
       max <- Lst$zlim[2]
    }
    if( !is.null(Lst$yLabels) ){
       yLabels <- c(Lst$yLabels)
    }
    if( !is.null(Lst$xLabels) ){
       xLabels <- c(Lst$xLabels)
    }
    if( !is.null(Lst$title) ){
       title <- Lst$title
    }
  }
# check for null values
if( is.null(xLabels) ){
   xLabels <- c(1:ncol(x))
}
if( is.null(yLabels) ){
   yLabels <- c(1:nrow(x))
}

layout(matrix(data=c(1,2), nrow=1, ncol=2), widths=c(4,1), heights=c(1,1))

 # Red and green range from 0 to 1 while Blue ranges from 1 to 0
 ColorRamp <- rgb( seq(0,1,length=256),  # Red
                   seq(0,1,length=256),  # Green
                   seq(1,0,length=256))  # Blue
 ColorLevels <- seq(min, max, length=length(ColorRamp))

 # Reverse Y axis
 reverse <- nrow(x) : 1
 yLabels <- yLabels[reverse]
 x <- x[reverse,]

 # Data Map
 par(mar = c(3,5,2.5,2))
 image(1:length(xLabels), 1:length(yLabels), t(x), col=ColorRamp, xlab="",
 ylab="", axes=FALSE, zlim=c(min,max))
 if( !is.null(title) ){
    title(main=title)
 }
axis(BELOW<-1, at=1:length(xLabels), labels=xLabels, cex.axis=0.7)
 axis(LEFT <-2, at=1:length(yLabels), labels=yLabels, las= HORIZONTAL<-1,
 cex.axis=0.7)

 # Color Scale
 par(mar = c(3,2.5,2.5,2))
 image(1, ColorLevels,
      matrix(data=ColorLevels, ncol=length(ColorLevels),nrow=1),
      col=ColorRamp,
      xlab="",ylab="",
      xaxt="n")

 layout(1)
}
# ----- END plot function ----- #


data(EU_NUTS1)

# Standard SMAA 
test <- ci_smaa_constr(EU_NUTS1,c(2,3), rep=200, label = EU_NUTS1[,1])
# source("http://www.phaget4.org/R/myImagePlot.R") 
# myImagePlot(test$ci_smaa_constr_rank_freq)
test$ci_smaa_constr_average_rank

# Constrained SMAA 
test2 <- ci_smaa_constr(EU_NUTS1,c(2,3), rep=200, label = EU_NUTS1[,1], low_w=c(0.2,0.2) )
# myImagePlot(test2$ci_smaa_constr_rank_freq)
test2$ci_smaa_constr_average_rank

}

\name{Compind-package}
\alias{Compind-package}
%\alias{Compind}
\docType{package}

\title{Composite Indicators - Compind}

\description{Compind package contains functions to enhance several approaches to the Composite Indicators (CIs) methods, focusing, in particular, on the normalisation and weighting-aggregation steps.}


\author{
Francesco Vidoli, Elisa Fusco
Maintainer: Francesco Vidoli <fvidoli@gmail.com>
}


\references{

Daraio, C., Simar, L. (2005) "\emph{Introducing environmental variables in nonparametric frontier models: a probabilistic approach}", Journal of productivity analysis, 24(1), 93-121.

Fusco E. (2015) "\emph{Enhancing non compensatory composite indicators: A directional proposal}", European Journal of Operational Research, 242(2), 620-630.

Fusco E. (2023) "\emph{Potential improvements approach in composite indicators construction: the Multi-directional Benefit of the Doubt model}", Socio-Economic Planning Sciences, vol. 85, 101447

Fusco, E., Liborio, M.P., Rabiei-Dastjerdi, H., Vidoli, F., Brunsdon, C. and Ekel, P.I. (2023), Harnessing Spatial Heterogeneity in Composite Indicators through the Ordered Geographically Weighted Averaging (OGWA) Operator. Geographical Analysis. https://doi.org/10.1111/gean.12384

R. Lahdelma, P. Salminen (2001) "\emph{SMAA-2: Stochastic multicriteria acceptability analysis for group decision making}", Operations Research, 49(3), pp. 444-454

OECD (2008) "\emph{Handbook on constructing composite indicators: methodology and user guide}".

Mazziotta C., Mazziotta M., Pareto A., Vidoli F. (2010) "\emph{La sintesi di indicatori territoriali di dotazione infrastrutturale: metodi di costruzione e procedure di ponderazione a confronto}", Rivista di Economia e Statistica del territorio, n.1.

Melyn W. and Moesen W.W. (1991) "\emph{Towards a synthetic indicator of macroeconomic performance: unequal weighting when limited information is available}", Public Economic research Paper 17, CES, KU Leuven.

Van Puyenbroeck T. and Rogge N. (2017) "\emph{Geometric mean quantity index numbers with Benefit-of-the-Doubt weights}", European Journal of Operational Research, 256(3), 1004-1014.

Rogge N., de Jaeger S. and Lavigne C. (2017) "\emph{Waste Performance of NUTS 2-regions in the EU: A Conditional Directional Distance Benefit-of-the-Doubt Model}", Ecological Economics, vol.139, pp. 19-32.

Simar L., Vanhems A. (2012) "\emph{Probabilistic characterization of directional distances and their robust versions}", Journal of Econometrics, 166(2), 342-354.

UNESCO (1974)"\emph{Social indicators: problems of definition and of selection}", Paris.

Vidoli F., Fusco E., Mazziotta C. (2015) "\emph{Non-compensability in composite indicators: a robust directional frontier method}", Social Indicators Research, 122(3), 635-652.

Vidoli F., Mazziotta C. (2013) "\emph{Robust weighted composite indicators by means of frontier methods with an application to European infrastructure endowment}", Statistica Applicata, Italian Journal of Applied Statistics.

Zanella A., Camanho A.S. and Dias T.G. (2015) "\emph{Undesirable outputs and weighting schemes in composite indicators based on data envelopment analysis}", European Journal of Operational Research, vol. 245(2), pp. 517-530.

}

\name{ci_bod_var_w}
\alias{ci_bod_var_w}
\title{Variance weighted Benefit of the Doubt approach (BoD variance weighted)}
\description{Variance weighted Benefit of the Doubt approach (BoD variance weighted) is a particular form of BoD method with additional information in the optimization problem. In particular it has been added weight constraints (in form of an Assurance region type I (AR I)) endogenously determined in order to take into account the ratio of the vertical variability of each simple indicator relative to one another.}

\usage{ci_bod_var_w(x,indic_col,boot_rep = 5000)}

\arguments{
  \item{x}{A data.frame containing score of the simple indicators.}
  \item{indic_col}{Simple indicators column number.}
  \item{boot_rep}{The number of bootstrap replicates (default=5000) for the estimates of the nonparametric bootstrap (first order normal approximation) confidence intervals for the variances of the simple indicators.}
}

\details{For more informations about the estimation of the confidence interval for the variances, please see function \emph{boot.ci}, package \emph{boot}.}

\value{An object of class "CI". This is a list containing the following elements:
  \item{ci_bod_var_w_est}{Composite indicator estimated values.}
  \item{ci_method}{Method used; for this function ci_method="bod_var_w".}
}

\references{Vidoli F., Mazziotta C. (2013) "\emph{Robust weighted composite indicators by means of frontier methods with an application to European infrastructure endowment}", Statistica Applicata, Italian Journal of Applied Statistics.}

\author{Vidoli F.}

\seealso{ \code{\link{ci_bod}}, \code{\link{ci_rbod}}}

\examples{
i1 <- seq(0.3, 0.5, len = 100) - rnorm (100, 0.2, 0.03)
i2 <- seq(0.3, 1, len = 100)   - rnorm (100, 0.2, 0.03)
Indic = data.frame(i1, i2)
CI = ci_bod_var_w(Indic)

}
